/*
 *   $RCSfile: bf_FreeTempPage.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:14 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


#include <stdio.h>
#include "ess.h"
#include "checking.h"
#include "io.h"
#include "page.h"
#include "list.h"
#include "object.h"
#include "tid.h"
#include "bf.h"
#include "bf_macro.h"
#include "chunk.h"
#include "trace.h"
#include "error.h"
#include "lock.h"
#include "bf_intfuncs.h"
#include "bf_extfuncs.h"
#include "bf_globals.h"


 void
bf_FreeTempPage (

	register GROUPLINK	*groupLink 
)
{

	register PAGEHASH	*pageHash;


	TRPRINT(TR_BF, TR_LEVEL_1, ("freeing slot:%d size:%d",
			groupLink->pageHash->pageInfo->bufIndex,
			BLOCKCOUNT(groupLink->pageHash->page2size)));

	/*
	 *	check magic numbers
	 */
	CHECK_GROUPLINK_MAGIC(groupLink);

	/*
	 *	Pull out the hash pointer
	 */
	pageHash = groupLink->pageHash;
	CHECK_PAGEHASH_MAGIC(pageHash);
	    
	/*
	 *	Must put it at the head of the LRU queue
	 */
	listPush( &(FreeBufTable[OFFSET(groupLink->pageHash->page2size)]),
			  &(groupLink->groupList) );

	/*
	 *	Set the group count to zero
	 */
	pageHash->memberCount = 0;
}
