/*
 *   $RCSfile: bf_UnfixUnlockPage.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:14 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


#include <stdio.h>
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "io.h"
#include "page.h"
#include "list.h"
#include "object.h"
#include "tid.h"
#include "bf.h"
#include "chunk.h"
#include "bf_macro.h"
#include "trans.h"
#include "lock.h"
#include "bf_intfuncs.h"
#include "bf_extfuncs.h"
#include "lm_extfuncs.h"
#include "trans_globals.h"


extern TRANSREC		TransRec;


 void
bf_UnfixUnlockPage (

	register GROUPLINK	*groupLink,
	int					replacePolicy,
	BOOL				dirty 
)
{
	LOCKMODE lockMode;

	SM_ASSERT(LEVEL_3, groupLink->fixedCount == 1);

	GET_PAGEHASHLOCK((groupLink->pageHash), lockMode);
	SM_ASSERT(LEVEL_3, lockMode == SH || lockMode == EX);
	SM_ASSERT(LEVEL_3, groupLink->pageHash->flags & UNLOCKABLE_PAGE);

	bf_UnfixPage(groupLink, replacePolicy, dirty);

	lm_UnlockPage(& (groupLink->pageHash->hashList.hashPid), 
											groupLink->pageHash);
									
	SET_PAGEHASHLOCK( (groupLink->pageHash), NL);
}
