/*
 * $RCSfile: BT_FirstEntry.C,v $
 * $Revision: 1.1.1.1 $
 * $Date: 1996/05/04 21:55:15 $
 */
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "BTREEPAGE.h"
#include "ParentStack.h"


int BT_FirstEntry(const PID& rootPid, int& found, TWO& slot, ParentStack& pl)
{
	found = FALSE;

	if (pl.ReadNPush(rootPid, SH))
		return esmFAILURE;

	BTREEPAGE* thisPage = pl.Top();
	PID pid = rootPid;

	while ( ! thisPage->IsLeaf() )  {
		pid.page = thisPage->FirstVector();
		if (pl.ReadNPush(pid, SH))
			return esmFAILURE;

		thisPage = pl.Top();

		pl.ReleasePrevious();
		}

	while (thisPage->NumSlots() <= 0)  {
		pid.page = thisPage->NextPage();

		if (pid.page == NULLPID)	// tree is empty
			return esmNOERROR;	

		pl.DiscardTop();

		if (pl.ReadNPush(pid, SH))
			return esmFAILURE;

		thisPage = pl.Top();
		}

	slot = 0;

	found = TRUE;
	return esmNOERROR;
}
