/*
 * $RCSfile: BT_IncrElCnt.C,v $
 * $Revision: 1.1.1.1 $
 * $Date: 1996/05/04 21:55:16 $
 */
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "BTREEPAGE.h"
#include "ParentStack.h"
#include "SMOPages.h"
#include "OVPAGE.h"

extern void IntPrint(int, char*);
extern void (*BT_PrintFunc)(int, char*);

#ifndef SERVER_MAKE
/* flaky trick to make the middle argument (not used on client side) 
 * issue a warning that's easy to recognize as something we can disregard:
 */
#define unused tid
#endif

int BT_IncrElCnt(TID unused, const PID& rootPid, BUFGROUP* bufGroup, 
					void* key, int keyLen, 
					int maxKeyLen, PFC compFunc, LSNOFFSET undoNxtLSN)

#ifndef SERVER_MAKE
#undef unused 
#endif
{
	TWO				slot;
	ParentStack		pl(bufGroup);
	int				found;

	//
	//	Traverse the tree
	//
	if (BT_Traverse(rootPid, keyLen, key, found,
							slot, pl, BT_INSERT, maxKeyLen, compFunc))  {
		return esmFAILURE;
		}
		
	if (!found)
		return esmFAILURE;

	BTREEPAGE* leaf = pl.Top();
	leaf->Tuple(slot).IncrElCnt();

	BT_LogLogicIncrElCnt(leaf->SelfID(), pl.Top(), leaf->lrc(),
							rootPid, key, keyLen, maxKeyLen,
							leaf->KeyType(), undoNxtLSN);
	
	pl.Top().Dirty();

	return esmNOERROR;
}
