/*
 * $RCSfile: BT_PrintTree.C,v $
 * $Revision: 1.1.1.1 $
 * $Date: 1996/05/04 21:55:15 $
 */
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "BTREEPAGE.h"



void BT_PrintTree(const PID& rootPid, BUFGROUP* bufGroup)
{
	PageDesc	pd;
	BTREEPAGE*	thisPage;
	int			i;

	if (pd.Read(bufGroup, rootPid, SH))  {
#ifdef SERVER_MAKE
		SM_ERROR(TYPE_FATAL, esmINTERNAL);
#else
		SM_ERROR(TYPE_LOG, sm_errno);
#endif
		return;
		}

	thisPage = pd;
	ASSERT3(thisPage->SelfID() == rootPid);
	
	for (i = 0; i < 5 - thisPage->Level(); i++)  {
		printf("\t");
		}
	printf("LEVEL %d, page %d: \n", thisPage->Level(), 
									thisPage->SelfID().page);

	thisPage->Print(bufGroup);

	if (thisPage->Level() != 1)    {
		PID	subTree;
		subTree.volid = thisPage->SelfID().volid;
		subTree.page = thisPage->FirstVector();
		BT_PrintTree(subTree, bufGroup);
		for (i = 0; i < thisPage->NumSlots(); i++)  {
			subTree.volid = rootPid.volid;
			subTree.page = thisPage->Tuple(i).Vector();
			BT_PrintTree(subTree, bufGroup);
			}
		}

	pd.Unfix();
}
