/*
 * $RCSfile: BT_SearchElemArray.C,v $
 * $Revision: 1.1.1.1 $
 * $Date: 1996/05/04 21:55:16 $
 */
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "BTREEPAGE.h"


//
//	Function	: int BT_SearchElemArray(int elSize, void* const el, int elCnt,
//											char* const elArray, int& idx)
//	Description	: Search elArray for el. Returns 
//				  TRUE and an index to elArray for the 
//				  located el if successful. Returns FALSE otherwise.
//
int BT_SearchElemArray(int elSize, const void* el, int elCnt, 
									const char* elArray, int& idx)
{
	int low, high;
	register mid;
	for (low = mid = 0, high = elCnt - 1; low <= high; )  {
		mid = (low + high)/2;
		int diff = BT_ElemDiff(elSize, el, elArray + mid * elSize);
		if (!diff) 	{
			idx = mid;
			return TRUE;
			}
		if (diff > 0) 
			low = mid + 1;
		else
			high = mid - 1;
		}

	idx = (low > mid) ? low : mid;

	return FALSE;
}
