/*
 * $RCSfile: BT_SetAnchor.C,v $
 * $Revision: 1.1.1.1 $
 * $Date: 1996/05/04 21:55:15 $
 */
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "sysdefs.h"
#include "BTREEPAGE.h"

#ifndef SERVER_MAKE
#	include "msgdefs.h"
#	include "msg_funcs.h"
#endif


int BT_SetAnchor(TID tid)
{
#ifndef SERVER_MAKE
	MESSAGE		message;
	

	/*
	 *	Force all log before setting anchor !!!
	 */
	if (clog_ForceLog(GET_SERVERINFO, MAXINT))  {
		return esmFAILURE;
		}

	/*
	 *	load up a message
	 */
	message.header.type = SET_ANCHOR;
	message.header.replyRequested = TRUE;
	message.header.params.in.tid	= GET_SERVERTID;

	/*
	 *	write the message
	 */
	if (callServer(GET_SERVERINFO, &message, NULL, 0) < 0)  {
		return esmFAILURE;
		}

	return esmNOERROR;
#else
	register TRANSREC* transRec = findTransRec(tid);
	if ( ! transRec)  {
		SM_ERROR(TYPE_USER, esmBADTRANSID);
		return esmFAILURE;
		}


	ASSERT3(transRec->rememberedLSN == NULL_LSN);

	transRec->rememberedLSN = transRec->lastLSN;
	
	BT_TRACE(("Setting anchor to %d\n", transRec->lastLSN));

	return esmNOERROR;

#endif
}
