/*
 * $RCSfile: OV_FreePage.C,v $
 * $Revision: 1.1.1.1 $
 * $Date: 1996/05/04 21:55:16 $
 */

/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "BTREEPAGE.h"
#include "OVPAGE.h"
#include "io_extfuncs.h"
#include "sm_macro.h"


//
//	Function	: int OV_FreePage(TID tid, PID& const pid)
//	Description	: Free the overflow page 'pid'.
//

#ifndef SERVER_MAKE
/* flaky trick to make the middle argument (not used on client side) 
 * issue a warning that's easy to recognize as something we can disregard:
 */
#define unused1 tid
#define unused2 pid
#endif

int OV_FreePage(TID unused1, const PID& unused2)

#ifndef SERVER_MAKE
#undef unused1 
#undef unused2 
#endif
{
#ifdef SERVER_MAKE
	// no one should call this function on server
	SM_ERROR(TYPE_FATAL, esmINTERNAL);
	return 0;
#else
	return io_DeallocPages(BTREE_PAGE2SIZE, 1, &pid, FALSE, PAGE_INDEX);
#endif
}
