/*
 * $RCSfile: bt_CreateBtree.C,v $
 * $Revision: 1.1.1.1 $
 * $Date: 1996/05/04 21:55:15 $
 */
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "BTREEPAGE.h"
#include "SMOPages.h"

//
//	Function	: int bt_CreateBtree(int volume, int groupIndex, PID& rootPid)
//	Description	: Create a one-node btree on volume, and returns the root
//				  pid.
//
int bt_CreateBtree(TID tid, int volume, BUFGROUP* bufGroup, 
									PID& rootPid, SMDATATYPE type)
{
	if (BT_SetAnchor(tid))  {
		return esmFAILURE;
		}
		
	//
	//	Allocate the root page for our index
	//
	if (BT_AllocPage(tid, volume, bufGroup, rootPid, 1, type)) {
		return esmFAILURE;
		}
	
	SMOPages smo;
	smo.Insert(rootPid);
	smo.Flush();

	if (BT_SetCLR(tid))  {
		return esmFAILURE;
		}
		
	return esmNOERROR;
}
