/*
 * $RCSfile: ov_DestroyCluster.C,v $
 * $Revision: 1.1.1.1 $
 * $Date: 1996/05/04 21:55:16 $
 */

/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "BTREEPAGE.h"
#include "OVPAGE.h"
#include "sm_macro.h"


//
//	Function	: int ov_DestroyCluster(TID tid, PID& const rootPid,
//													BUFGROUP* bufGroup)
//	Description	: Destroy the overflow pages. All pages are freed.
//
int ov_DestroyCluster(TID tid, const PID& rootPid, BUFGROUP* bufGroup)
{
	PID pid = rootPid;

	//
	//	Free all pages
	//
	while (pid.page != NULLPID)  {
		PageDesc pageDesc;

		if (pageDesc.Read(bufGroup, pid, EX))
			return esmFAILURE;

		SHORTPID next = ((OVPAGE*)pageDesc)->NextPage();
		pageDesc.Unfix();

		if (OV_FreePage(tid, pid)) return esmFAILURE;

		pid.page = next;
		}

	return esmNOERROR;
}
