/*
 *   $RCSfile: CLOG_UpdateLogPageHeader.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:17 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "pool.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "bf.h"
#include "chunk.h"
#include "sm_macro.h"
#include "lsn.h"
#include "loginfo.h"
#include "volume.h"
#include "trans.h"
#include "clog.h"
#include "logrecs.h"
#include "clog_intfuncs.h"

    
/***************************************************************
 * 	
 *  PURPOSE	
 *	Update the log page header to point to the last record added
 *	to the page
 *  
 ***************************************************************/

void
CLOG_UpdateLogPageHeader(

    LOGINFO			*logInfo,
	int				lastRecord 
)
{
	LOGPAGEHDR	*pageHeader;

	/*
	 *	get a pointer to the page header and update the last record info
	 */
	pageHeader = (LOGPAGEHDR *) logInfo->tailBuffer->pageInfo->bufFrame;
	pageHeader->lastRecord = lastRecord;

	/*
	 *	get the header on the end of the page and update it also
	 */
	pageHeader = (LOGPAGEHDR *) (((ONE *) pageHeader) + logInfo->lastUsableByte);
	pageHeader->lastRecord = lastRecord;

}
