/*
 *   $RCSfile: clog_LogChangeSmSize.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:17 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "pool.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "bf.h"
#include "chunk.h"
#include "lsn.h"
#include "loginfo.h"
#include "volume.h"
#include "trans.h"
#include "clog.h"
#include "logrecs.h"
#include "logaction.h"
#include "serverinfo.h"
#include "util_funcs.h"
#include "clog_intfuncs.h"
#include "clog_extfuncs.h"
#include "clog_globals.h"
#include "trans_globals.h"


int	
clog_LogChangeSmSize(

    OID		*objOid,
    OBJHDR	*objHeader,
    int		oldSize,
	int		newSize 
)
{

    OPERATIONINFO 	opInfo;
    OBJHDR	oldHeader,newHeader;


    /* create the old and new object header images */ 
    oldHeader = *objHeader;
    oldHeader.size = oldSize; 
    newHeader = *objHeader;
    newHeader.size = newSize; 
	

    /* set up operation info to log change to header*/
    opInfo.action = LOG_ACTION_CHANGE_SMALL_OBJHDR;
    opInfo.flags =0 ;
    opInfo.oid = *objOid;
    opInfo.start = 0;
    opInfo.size = sizeof(OBJHDR);
    opInfo.oldData = (char*) &oldHeader;
    opInfo.newData = (char*) &newHeader;
    opInfo.actionPid.volid = objOid->diskAddr.volid;
    opInfo.actionPid.page  = objOid->diskAddr.page;

    /* peform the logging as a generic header update */
    CLOG_LogChangeSmHeader(&opInfo);

	return(esmNOERROR);
}  	
