#ifndef _BF_EXTFUNCS_H_
#define _BF_EXTFUNCS_H_
/*
 *   $RCSfile: bf_extfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:19 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "forward.h"

BEGIN_EXTERNC

extern void			bf_UnfixGroup (BUFGROUP *);
extern void			bf_ShutGroup (BUFGROUP *);
extern int			bf_CloseGroup (BUFGROUP *);
extern int			bf_DiscardGroup (BUFGROUP *);
extern BOOL			bf_FreeUnfixedGroup (BUFGROUP *, BOOL);
extern int			bf_CheckBitmap (PID *, int);
extern void			bf_CleanPage (PAGEHASH *);
extern void			bf_DeleteChunk (CHUNKDESC *, int, int);
extern int			bf_DirtyChunk (int, CHUNKPAGE *, CHUNKDESC *);
extern void			bf_DirtyPage (PAGEHASH *);
extern void			bf_DiscardPage (BUFGROUP *, GROUPLINK *);
extern int			bf_DismountVolume (VOLID);
extern void			bf_FreeTempPage (GROUPLINK *);
extern CHUNKDESC	*bf_GetChunkBuf (BUFGROUP *, PAGE2SIZE);
extern GROUPLINK	*bf_GetPage (BUFGROUP *, const PID *, PAGETYPE, char **, PAGE2SIZE);
extern GROUPLINK	*bf_GetPageBuf (BUFGROUP *, PAGE2SIZE);
extern GROUPLINK	*bf_GetTempPage (PAGE2SIZE);
extern void			bf_HackChunkPage (PID *, BOOL all = FALSE);
extern int			bf_Init (void);
extern int			bf_InsertChunk (int, CHUNKPAGE *, CHUNKDESC *, int, int);
extern void			bf_InsertObjectEntry (OID *, USERDESC *);
extern BUFGROUP		*bf_OpenGroup (int, int, FLAGS);


extern void			bf_PurgeFilePages (FID *);
extern int			bf_ReadChunk (FID *, BUFGROUP *, int, int, CHUNKPAGE *,
								  int, int, CHUNKDESC **);
extern GROUPLINK	*bf_ReadPage (BUFGROUP *, const PID *, PAGETYPE, PAGE2SIZE, 
								LOCKMODE);
extern int			bf_CheckForSpace (BUFGROUP *, int, BOOL);
extern int			bf_BreakdownChunk (BUFGROUP *, int);
extern GROUPLINK	*bf_ScanPage (BUFGROUP *, const PID *, SCANTYPE, PID *, FID *,
NEIGHBORFLAGS);
extern GROUPLINK	*bf_FakeReadPage (BUFGROUP *, const PID *, PAGETYPE, PAGE2SIZE);
extern void			bf_ReleaseFileUserDesc (FID *);
extern void			bf_RenamePage (PAGEHASH *, const PID *, PAGETYPE);
extern void			bf_Shutdown ();
extern void			bf_UnfixChunk (CHUNKDESC *, int);
extern void			bf_UnfixPage (GROUPLINK *, int, BOOL);
extern void			bf_UnfixUnlockPage (GROUPLINK *, int, BOOL);
extern int			bf_ReplaceLeafChunk (CHUNKDESC*, CHUNKPAGE*, PID*, PID*);
extern void			bf_ForcePage (PAGEHASH*, BFFLAGS);
extern void			bf_ForceLogPage (SERVERINFO *, PAGEHASH*, BFFLAGS);
extern int          bf_UpdateLogicalLink (BUFGROUP *, PID *, SHORTPID);

extern void			bf_InvalidatePage (PAGEHASH *, BOOL, BOOL);
extern PAGEHASH*	bf_FindPage(const PID*);
extern LRC*			bf_lrcLoc(PAGEHASH *);
extern int			bf_Swap (BUFGROUP *, int);
extern void			bf_UpdateChunkPage (CHUNKPAGE *, int, int, char *);
extern void			bf_ShutGroup (BUFGROUP *);
extern int			bf_FindChunkSize (int);
extern void 		bf_ForEachPageInHashTable( void *, void *);


#ifdef COMMENT
extern void			bf_FlushDirty (void);
#endif COMMENT
extern void			bf_RemoveFromBufGroups (PAGEHASH *);
extern void			bf_FlushAll (BOOL, BOOL x = FALSE);

END_EXTERNC

/* BEGIN visible to staff */
BEGIN_EXTERNC
extern int			bf_CountFixed ();
extern void			bf_PrintFixed ();
extern void			bf_PrintFixedBG (BUFGROUP *);
extern void			bf_PrintUnfixedBG (BUFGROUP *);
#ifdef DEBUG
extern void			printFreeBufTable (void);
extern void 		printUnfixedList(BUFGROUP *);
extern void 		printFixedList(BUFGROUP *);
#endif DEBUG
END_EXTERNC
/* END visible to staff */
#endif /* _BF_EXTFUNCS_H_ */
