#ifndef __BF_INTFUNCS_H__
#define __BF_INTFUNCS_H__
/*
 *   $RCSfile: bf_intfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:19 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

BEGIN_EXTERNC

#ifdef DEBUG
extern void			BF_AuditGroup (BUFGROUP *);
extern void			BF_AuditChunkPage(CHUNKPAGE *); 
extern void			BF_AuditInvalidChunk( CHUNKDESC *);
extern void			BF_AuditChunk( CHUNKDESC *);
#endif

extern int			BF_CloseGroup (BUFGROUP *, BOOL);
extern int			BF_InitPageHash (void);
extern int			BF_InitBuffers (void);
extern int			BF_Shutdown();
extern void			BF_FlushChunk (CHUNKDESC *, BOOL);
extern void			BF_FreeBlock (CHUNKDESC *);
extern void			BF_FreeChunk (BUFGROUP *, CHUNKDESC *);
extern void			BF_FreePage (BUFGROUP *, GROUPLINK *, BOOL);
extern char			*BF_GetLarger (PAGE2SIZE, int);
extern char			*BF_GetSmaller (PAGE2SIZE, int);
extern BUFINFO		*BF_FindFreeSlot (PAGE2SIZE);
extern void			BF_InsertHashEntry (PAGEHASH *, const PID *, PAGETYPE);
extern void			BF_AssertPageHashTableEmpty (void);
extern void			BF_DeleteHashTable (void);
extern PAGEHASH		*BF_NewPageHash (void);
extern void			BF_DiscardPageHash (PAGEHASH *);
extern void			BF_InvalidateChunk (CHUNKDESC *);
extern void			BF_DiscardChunk (CHUNKDESC *);
extern int			BF_InvalidateUserDesc (USERDESC *);
extern void			BF_PurgeFilePages (FID *);
#ifdef DEBUG
	extern void			BF_ReplacePolicy (BUFGROUP *, LIST *, int);
#endif
extern void			BF_SetSlot (BUFINFO *, int, char *, int);
extern void			BF_RemovePageFromHT (PAGEHASH *);
extern GROUPLINK	*BF_ReadPageWithNeighbor (BUFGROUP *, const PID *, PAGETYPE,
					PAGE2SIZE, LOCKMODE, NEIGHBORFLAGS, FID *, PID *);

END_EXTERNC

#endif __BF_INTFUNCS_H__
