#ifndef _CLOG_H_
#define _CLOG_H_
/*
 *   $RCSfile: clog.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:19 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

/* Define the size of the log buffer group on a client 
			(specified in terms of log pages) */
#define CLOG_BUFGROUP_SIZE 1

/*
 *	Information about an operation to be logged from a client.
 */

typedef struct	{

	UONE	type;		/* type of record entry	*/
	UONE	action;		/* operation we are logging*/
	UONE	flags;
	OID		oid;		/* oid of object the action applies to	*/
	FOUR	start;  	/* byte of object operation starts at */
	FOUR	size;  		/* number of bytes affected*/
	ONE 	*oldData; 	/* data that was overwritten*/
	ONE 	*newData;	/* new data values added*/
	PID		actionPid;      /* PID of page */
	LRC		currentLRC;     /* NOTE: THIS FIELD IS NO LONGER USED
					AND IS NOT SET BY MOST OPERATIONS.
					LRC of page at time of operation */
	SLOTINDEX	rootSlot;	/* slot number if the referenced object is
					a slotted lg obj root on a slotted
					page.  NIL otherwise.  NOTE: this
					field is meaningful only for large
					object operations */

} OPERATIONINFO;

#endif /* _CLOG_H_ */
