#ifndef _FI_EXTFUNCS_H_
#define _FI_EXTFUNCS_H_
/*
 *   $RCSfile: fi_extfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:19 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "file.h"

BEGIN_EXTERNC

extern int			fi_CreateFile (VOLID, PID *, FID *, FLAGS);
extern int			fi_DestroyFile (FID *);
extern int			fi_Page (FID *, PID *, FLAGS);
extern int			fi_MarkPage (FID *, SHORTPID);
extern int			fi_NeighborPid (PID *, FID *, SHORTPID **, SHORTPID **, FLAGS, PID *);

extern int			fi_InitFileInfoTable ();
extern void			fi_FreeFileInfoTable ();
extern FILEINFO*	fi_FindFileInfo (FID *, BOOL);
extern void			fi_RemoveFileInfo (FID *);
extern void			fi_SetAllFileLogLevel (FLAGS);
extern BOOL			fi_IsLoggingOff ();
extern void			fi_MarkLoggingOff ();
extern int			fi_NumPages(FID*, int*);
extern void			fi_InvalidateHints();

END_EXTERNC
#endif /* _FI_EXTFUNCS_H_ */
