#ifndef _FI_MACRO_H_
#define _FI_MACRO_H_
/*
 *   $RCSfile: fi_macro.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:19 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


/*
 *	define magic number checks
 */
#if MAGIC_CHECKING IS_ENABLED


#define CHECK_FIDHASH_MAGIC(_fidHash)						\
															\
	if ((_fidHash)->magic != FIDHASH_MAGIC)	{				\
		SM_ERROR(TYPE_FATAL, esmINTERNAL);					\
	}


#define INIT_FIDHASH_MAGIC(_fidHash)						\
															\
	(_fidHash)->magic = FIDHASH_MAGIC;



#else


#define CHECK_FIDHASH_MAGIC(_fidHash)

#define INIT_FIDHASH_MAGIC(_fidHash)


#endif


#define 		fi_FirstLogicalPage(a,b) fi_Page(a,b,FI_FIRST | LOGICAL_SCAN)
#define 		fi_FirstPhysicalPage(a,b) fi_Page(a,b,FI_FIRST | PHYSICAL_SCAN)
#define 		fi_LastLogicalPage(a,b) fi_Page(a,b,FI_LAST | LOGICAL_SCAN)
#define 		fi_LastPhysicalPage(a,b) fi_Page(a,b,FI_LAST | PHYSICAL_SCAN)
#endif /* _FI_MACRO_H_ */
