#ifndef _FILE_H_
#define _FILE_H_
/*
 *   $RCSfile: file.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:20 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

/*
 * constants to specify sibling/neighbour position
 */
#include "fi_msg.h"
#define		BEFORE 		NEIGHBOR_BEFORE
#define		AFTER		NEIGHBOR_AFTER
#define		ANY			NEIGHBOR_ANY	/* means any available neighbor,
					 		 * regardless of position
					 		 */

/* BEGIN visible to user */

/*
 *	define flags for file creation parameters
 */
#define LOGICAL_ORDER	0x1

/* END visible to user */

/* These must not conflict with SCANTYPE values in ./scan.h, */
#define FI_FIRST 0x40
#define FI_LAST 0x80


/*
 * File information table structures for the client
 */
typedef struct _FileInfo {
	FID			fid;
	FLAGS		logLevel;
	BOOL		tempVolume;
	SHORTPID	firstPageHint;
	SHORTPID	lastPageHint;
} FILEINFO;

#endif /* _FILE_H_ */
