#ifndef _LG_EXTFUNCS_H_
#define _LG_EXTFUNCS_H_
/*
 *   $RCSfile: lg_extfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:20 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

BEGIN_EXTERNC

extern int	lg_CreateObject (FID *, PID *, BUFGROUP *, int, char *, PID *, SLOTINDEX);
extern int	lg_DeleteFromObject (FID *, PID *, BUFGROUP *, int, int, SLOTINDEX, BOOL);
extern int	lg_DestroyObject (PID *, BUFGROUP *, SLOTINDEX, BOOL, BOOL);
extern int	lg_InsertInObject (FID *, PID *, BUFGROUP *, int, int, char *, SLOTINDEX, BOOL);
extern int	lg_AppendToObject (FID *, PID *, BUFGROUP *, int, char *, SLOTINDEX, BOOL);
#ifdef DEBUG
	extern void	lg_PrintIndex (BUFGROUP *, PID *, int, BOOL, SLOTINDEX);
	extern void	lg_PrintNode (LGNODE *, int, SHORTPID);
#endif
extern int	lg_ReadObject (FID *, PID *, BUFGROUP *, int, int, CHUNKDESC **, SLOTINDEX);
extern int	lg_ReleaseObject (CHUNKDESC *);
extern int	lg_WriteObject (CHUNKDESC *, char *, int, int, BOOL, char *);
extern int  lg_WroteObject (CHUNKDESC *, char *, int, int, BOOL, char *);
extern int	lg_Init ();
extern int	lg_GetRootNodePid (BUFGROUP*, OID*, PID*, SLOTINDEX*);

END_EXTERNC
#endif /* _LG_EXTFUNCS_H_ */
