#ifndef _LG_INTFUNCS_H_
#define _LG_INTFUNCS_H_
/*
 *   $RCSfile: lg_intfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:20 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

BEGIN_EXTERNC

extern void			sm_SetAbortIfError(); /* keep this here */

extern int			LG_AllocNodes (BUFGROUP *, CHUNKPAGE *, PID *, int);
extern int			LG_AppendData (FID *, int, char *, PAGELIST *, 
								   PAGELIST *, BUFGROUP *, BOOL, BOOL*, PID*);
extern int			LG_AppendIndex (int, int, int, int, PAGELIST *, LGNODE *, int);
extern void			LG_AppendPage (PAGELIST *, PID *, int, BOOL,
								   GROUPLINK *, SHORTPID, int, int, BOOL);
extern int			LG_BalanceData (FID *, BUFGROUP *, PID*, SLOTINDEX, LGNODE *, SLOTINDEX *, BOOL, BOOL);
extern int			LG_BinarySearch (LGNODE *, int);
extern int			LG_ComputeAppend (int, PAGELIST *, PAGELIST *, TSTACK *);
extern int			LG_ComputeInsert (int *, int, PAGELIST *, PAGELIST *, TSTACK *);
extern int			LG_DeleteData (FID *, PID *, int, int, int,
								   BUFGROUP *, PID *, BOOL *, BOOL);
extern int			LG_DeletePhase (FID *, PID *, SLOTINDEX, PID *, 
									SLOTINDEX, int, int, BUFGROUP *, 
									PID *, TSTACK *, TSTACK *, BOOL *,
									BOOL, BOOL);
extern int			LG_FixIndex (PID *, PAGELIST *, TSTACK *, BUFGROUP *, int);
extern int			LG_FixLast (PAGELIST *, TSTACK *);
extern int			LG_InitList (PAGELIST *, int);
extern int			LG_InsertData (FID *, int, int, char *, 
								   PAGELIST *, PAGELIST *, BUFGROUP *, 
								   BOOL, BOOL*, PID*);
extern void			LG_InsertPage (PAGELIST *, PID *, int, BOOL, GROUPLINK *, SHORTPID, int, BOOL);
extern void			LG_Merge (PID*, SLOTINDEX, LGNODE*, SLOTINDEX, PID*,
							  LGNODE*, PID*, LGNODE*, int*);
extern TSTACKENT	*LG_PopTstack (TSTACK *);
#ifdef DEBUG
extern void			LG_PrintTstack (TSTACK *);
#endif DEBUG
extern int			LG_PushTstack (TSTACK *, SLOTINDEX, PID *, LGNODE *, 
								   BOOL, int, GROUPLINK *, SLOTINDEX, 
								   BOOL);
extern int			LG_Reshuffle (PID*, SLOTINDEX, LGNODE *, SLOTINDEX, PID*, LGNODE *, PID*, LGNODE *, int *);
extern int			LG_ScanForLeaves (PID *, int *, int *, BUFGROUP *,
									  PAGELIST *, int *, SLOTINDEX, 
									  BOOL);
extern int			LG_Shadow (PID *, PID *, PID *, BUFGROUP *, GROUPLINK **);
extern int			LG_SlotCount (LGNODE *, SLOTINDEX);
extern TSTACKENT	*LG_TopTstack (TSTACK *);
extern void			LG_UnfixTstack (TSTACK *, BOOL);
extern int			LG_Traverse (PID *, int *, int, OBJOP,
								 TSTACK *, BUFGROUP *, SLOTINDEX, BOOL,
								 int, int *);
extern int			LG_ZipUpIndex (FID *, PID *, BUFGROUP *, TSTACK *, TSTACK *, BOOL);
extern int			LG_AppendToObject (FID *, PID *, BUFGROUP *, int, 
									   char *, SLOTINDEX);
END_EXTERNC

#ifndef DEBUG


/*
 * Calculate and return a given slot's byte count.
 */
#define LG_SlotCount(_nodePtr, _slotNo)             \
                                                    \
    ( ((_slotNo) == 0)                              \
        ? ((_nodePtr)->slot[(_slotNo)].count)       \
        : ((_nodePtr)->slot[(_slotNo)].count        \
        - (_nodePtr)->slot[(_slotNo)-1].count) )


#endif

#endif /* _LG_INTFUNCS_H_ */
