#ifndef _LG_VERSIONFUNCS_H_
#define _LG_VERSIONFUNCS_H_
/*
 *   $RCSfile: lg_versionfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:20 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


#ifdef __cplusplus
extern "C" {
#endif

extern int  lg_CreateVersionRoot ( BUFGROUP*, FID*, PID*, LARGEOBJHDR*, LARGEOBJHDR*, VHGNODEID);
extern int	lg_GetVHGPtr (BUFGROUP*, LARGEOBJHDR*, VOLID, VHGNODEPTR*);
extern int	lg_SetVHGPtr (BUFGROUP*, LARGEOBJHDR*, VHGNODEPTR*, OID *);
extern int	lg_DestroyVersion (BUFGROUP*, PID*, SLOTINDEX, BOOL, BOOL,
								VERSIONGRAPH*, BOOL*, BOOL*, OID*, BOOL*);


extern int			LG_ReplaceIfShared (BUFGROUP*, PID*, SLOTINDEX, 
										PID*, int, PID*, BOOL*);
extern int			LG_UpdateLeafParent (CHUNKDESC*, CHUNKPAGE*, CHUNKPAGE*);
extern void			LG_CountShared (CHUNKDESC*, int, int, int*);
extern int			LG_BuildShareStack (PID*, SLOTINDEX, PID*, int, 
										TSTACK*, BUFGROUP*, int*);
extern int			LG_ReplaceSharedLeaves (CHUNKDESC*, int, int, PID*, BOOL);
extern int			LG_ChangeWritePageId(CHUNKDESC*, PAGELIST*);
extern int			LG_ReplaceSharedNodes(BUFGROUP*, PID*, TSTACK*,
										  int, PID*);
extern int			LG_HashChildren (BUFGROUP*, PID*, SLOTINDEX, LIST*,
									 LGNODEHASHTABLE*, POOL*, BOOL);
extern int			LG_DestroyVersionPage (BUFGROUP*, LIST[], LIST[],
									 LGNODEHASHTABLE*, POOL*, int, int,
									 PID*, SLOTINDEX);
extern int			LG_SortRootNodeChildren (BUFGROUP*, LIST*, LIST[], 
											 LGNODEHASHTABLE*, POOL*);
extern LGNODELIST*	LG_HashFindNode (PID*, SLOTINDEX, LGNODEHASHTABLE*);
extern BOOL			LG_HashPutNode (LGNODEHASHTABLE*, LGNODELIST*);
extern unsigned int		LG_HashPid (PID*, LGNODEHASHTABLE*);
extern void			LG_HashTableInit (LGNODEHASHTABLE*);
extern LGNODELIST*	LG_AllocateNodeListElement (POOL*);
extern int			LG_InitGlobals();
extern void			LG_RecycleNodeListElements(POOL*, LIST*);

#ifdef __cplusplus
}
#endif


#endif /* _LG_VERSIONFUNCS_H_ */
