#ifndef _SCAN_H_
#define _SCAN_H_
/*
 *   $RCSfile: scan.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:20 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

/* BEGIN visible to user */

typedef struct struct_scan_desc SCANDESC;

/* END visible to user */

struct struct_scan_desc {

	BUFGROUP		*bufGroup;
	FID				fid;
	SLOTTEDPAGE		*currentPage;
	GROUPLINK		*currentLink;
	USERDESC		*currentUser;
	SHORTPID		*pidListBegin; /* free()-able */
	SHORTPID		*pidListCurrent; /* "matches" currentPid except that
									 * the currentPid might not be in the
									 * pid list.  (The list is a neighbor
									 * list.)  If not, the this points to
									 * where the current pid would be, were
									 * it present.  It is at most one beyond
									 * the beginning or end of the neighbor
									 * list.
									 */
	SHORTPID		*pidListEnd;
	PID				currentPid;
	SHORTPID		*nextPid;
	SHORTPID		nextLogicalPid;
	SLOTINDEX		currentSlot;
	int				currentStart;
	int				currentSize;
	LISTELEMENT		scanList;
	SCANFLAGS		flags;
	SCANTYPE		type;
	BOOL			removeGroup;
	MAGIC			magic;
} ;


#define SCANDESC_MAGIC		0xef5074df

/* BEGIN visible to user */

/*
 *	types of allowed scans
 */
#define LOGICAL_SCAN	0x1
#define PHYSICAL_SCAN	0x2

/* END visible to user */


/*
 *	values for typedef SCANFLAGS
 */
#define SCAN_BEGIN		0x1
#define SCAN_END		0x2
#define SCAN_LARGE		0x4
#define SCAN_FORWARDED	0x8
#endif /* _SCAN_H_ */
