#ifndef _SEQUENTIALFILE_H_
#define _SEQUENTIALFILE_H_
/*
 *   $RCSfile: sequentialfile.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:20 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

/*
 *	define the sequential load descriptor
 */
typedef struct	{

	RESOURCEID		id;
	UNIQUE			unique;
	LIST			list;
	FLAGS			flags;
	int				index;

#if MAGIC_CHECKING IS_ENABLED

	MAGIC			magic;

#endif

} SEQLOADDESC;


#define SEQLOADDESC_MAGIC		0xf2d1557a


/*
 *	define the states of the load descriptors
 */
#define SEQLOAD_FREE	0x0
#define SEQLOAD_ACTIVE	0x1


/*
 *	define the sequential load descriptor
 */
typedef struct	{

	RESOURCEID		id;
	UNIQUE			unique;
	LIST			list;
	FLAGS			flags;
	int				index;

#if MAGIC_CHECKING IS_ENABLED

	MAGIC			magic;

#endif

} SEQSCANDESC;


#define SEQSCANDESC_MAGIC		0x8493273e


/*
 *	define the states of the load descriptors
 */
#define SEQSCAN_FREE	0x0
#define SEQSCAN_ACTIVE	0x1


/*
 *	define the magic macros for the sequential structures
 */
#if MAGIC_CHECKING IS_ENABLED


#define INIT_SEQSCANDESC_MAGIC(_scanDesc)				\
	(_scanDesc)->magic = SEQSCANDESC_MAGIC;

#define INIT_SEQLOADDESC_MAGIC(_loadDesc)				\
	(_loadDesc)->magic = SEQLOADDESC_MAGIC;

#define CHECK_SEQSCANDESC_MAGIC(_scanDesc)				\
														\
	if ((_scanDesc)->magic != SEQSCANDESC_MAGIC)	{	\
		SM_ERROR(TYPE_FATAL, esmINTERNAL);				\
	}

#define CHECK_SEQLOADDESC_MAGIC(_loadDesc)				\
														\
	if ((_loadDesc)->magic != SEQLOADDESC_MAGIC)	{	\
		SM_ERROR(TYPE_FATAL, esmINTERNAL);				\
	}


#else


#define INIT_SEQSCANDESC_MAGIC(_scanDesc)

#define INIT_SEQLOADDESC_MAGIC(_loadDesc)

#define CHECK_SEQSCANDESC_MAGIC(_scanDesc)

#define CHECK_SEQLOADDESC_MAGIC(_loadDesc)


#endif


#endif /* _SEQUENTIALFILE_H_ */
