#ifndef _SM_INTFUNCS_H_
#define _SM_INTFUNCS_H_
/*
 *   $RCSfile: sm_intfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:20 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include	"trans.h"
BEGIN_EXTERNC

extern int		SM_AppendForward (BUFGROUP *, GROUPLINK *, OID *, int, char *);
extern int		SM_AppendToLarge (FID *, BUFGROUP *, OID *, GROUPLINK *, 
								  LARGEOBJHDR *, int, char *, SLOTINDEX);
extern int		SM_CheckFree (SLOTTEDPAGE *, GROUPLINK *, SLOTINDEX, SMALLOBJ *, int);
extern int		SM_CheckPageUse (GROUPLINK *);
extern int		SM_CompactPage (SLOTTEDPAGE *, SLOTINDEX);
extern int		SM_ConvertAppend (BUFGROUP *, OID *, PID *, GROUPLINK *,
								  int, int, char *, char *);

extern int		SM_ConvertInsert (BUFGROUP *, OID *, PID *, GROUPLINK *,
								  int, int, int, char *, char *);
extern int		SM_CreateAppend (BUFGROUP *, FID *, OID *, int, GROUPLINK *,
								 char *, char *, int, OID *, OBJHDR *);
extern int		SM_CreateInsert (BUFGROUP *, FID *, OID *, int, GROUPLINK *, int,
								 char *, char *, int, OID *, OBJHDR *);
extern int		SM_DecideNear (int, OID *, PID *, FID *, BOOL *);
extern int		SM_DeleteForward (BUFGROUP *, OID *, int, int);
extern int		SM_DestroyForward (BUFGROUP *, OID *);
extern int		SM_Init (void);
extern void		SM_Shutdown (void);
extern int		SM_InitLoadDesc (void);
extern int		SM_InitScanDesc (void);
extern int		SM_InsertForward (BUFGROUP *, GROUPLINK *, OID *, int, int, char *);
extern int		SM_InsertInLarge (FID *, BUFGROUP *, OID *, PID *, GROUPLINK *, LARGEOBJHDR *,
								  int, int, char *, SLOTINDEX);
extern int		SM_LoadNextObject (LOADDESC *, int, char *, OID *);
extern int		SM_OpenLoad (FID *, LOADDESC *);
extern int		SM_OpenScan (FID *, SCANDESC *, OID *, SCANTYPE);
extern int		SM_ReadForward (BUFGROUP *, GROUPLINK **, OID *, int, int *);
extern int		SM_ReadObjectAux (GROUPLINK *, PID *, BUFGROUP *, OID *, int, int, USERDESC **,
							   USERDESC *, BOOL);
extern int		SM_ReadObject (BUFGROUP *, OID *, int, int, USERDESC **,
							   USERDESC *, BOOL, LOCKMODE);
extern USERDESC	*SM_ReadScanObject (SCANDESC *);
extern void		SM_ReleaseList (OID *);
extern int		SM_ReleaseObject (USERDESC *);
extern int		SM_InvalidateUserDesc (USERDESC *);
extern int		SM_ReleaseScanObject (SCANDESC *);
extern void		SM_RestoreDesc (LIST *);
extern int		SM_ReturnSlot (GROUPLINK *, SLOTINDEX, int);
extern int		SM_ScanNext(SCANDESC *, int, int, USERDESC **, BOOL *);
extern LIST		*SM_SuspendDesc (OID *, USERDESC *);
extern int		SM_TryNearPage (BUFGROUP *, FID *, int, BOOL *,
								PID *, GROUPLINK **, BOOL *);
extern int		SM_TryNeighbor (BUFGROUP *, int, GROUPLINK *, BOOL *, PID *, GROUPLINK **);
extern int		SM_LargeObjOnPage (SLOTTEDPAGE *);
extern int		SM_GetNextPrevOid PROTO((int, OID *, OID *, OBJHDR *, BOOL *,NEIGHBORFLAGS ));
extern int		SM_GetFirstLastOid PROTO((int, FID *, OID *, OBJHDR *, BOOL *, FLAGS));
extern int 		SM_GetOid PROTO((BUFGROUP *, GROUPLINK *, SLOTINDEX, OID *, PID *, OBJHDR	*, BOOL	*, FLAGS));

extern int 		SM_NeighborPids PROTO((SCANDESC *, NEIGHBORFLAGS));
extern int 		SM_SetLogServerState (GROUPLINK *, OID *);

extern int		SM_ConvertDelete (BUFGROUP *, OID *, PID *, GROUPLINK *, OBJECT *, int, PID *, SLOTINDEX);
extern int      SM_TransBulkloading(TID );
extern int      SM_InsertIndexLoad(IID* , void*, int, void* );

extern void     SM_AbortIfRequired();


/*
 * options processing
 */
extern int		SM_InitClientOptions ();
extern int		SM_CheckRequiredOptions ();
extern int      SM_SetOption(const char*, const char*);

extern int		SM_AbortAllIndexLoads (TID);

extern int		newTid();
extern int		pickCoord(TRANSREC *);

END_EXTERNC
#endif /* _SM_INTFUNCS_H_ */
