#ifndef _SM_PARAMS_H_
#define _SM_PARAMS_H_
/*
 *   $RCSfile: sm_params.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:20 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

/*
 *	these parameters adjust the storage manager configuration
 */

/*
 *	Client options
 *  (in alphabetical order so that it's easy to tell if you're
 *  introducing a conflict when you add a new option)
 */
enum {	SM_OPT_bufpages, 
		SM_OPT_deallocpages,
		SM_OPT_filelock, 
		SM_OPT_groups, 
		SM_OPT_locktimeout,
		SM_OPT_lognewpages, 
		SM_OPT_mount, 
		SM_OPT_pagelock,
		SM_OPT_traceflags, 
		SM_OPT_userdesc
	};
#define NUM_OPTIONS				15


/* BEGIN visible to user */

#define SM_MAXKEYLEN			1024	/* max length of index key */

#define SM_MAXOPTCLASS			10		/* max # of option classification levels */

/* END visible to user */

/* 
 * moved the following 
 * from sm_extfuncs because it really shouldn't be an sm ext func
 * and keeping it there makes it necessary to include all sorts
 * of otherwise  unnecessary include files all over the place.
 */
#ifdef DEBUG
#	define 	sm_AuditSlotPage(x)   SM_AuditSlotPage(x, __FILE__, __LINE__)
BEGIN_EXTERNC
	extern void		SM_AuditSlotPage PROTO((SLOTTEDPAGE *, char *, int ));
	extern void		sm_PrintPage PROTO((SLOTTEDPAGE * ));
	extern void		sm_PrintSlotPage PROTO((SLOTTEDPAGE * ));
END_EXTERNC
#else
#	define 	sm_AuditSlotPage(x)   /*comment*/
#	define	sm_PrintPage(x)	     /*comment*/
#	define	sm_PrintSlotPage(x)  /*comment*/
#endif

#endif _SM_PARAMS_H_
