#ifndef _VERSION_FUNCS_H_
#define _VERSION_FUNCS_H_
/*
 *   $RCSfile: version_funcs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:20 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

/*
 *	Macros and declarations of functions dealing with versions and 
 *	version history graphs
 */

/*
 *  This macro calculates the offset from the beginning of the graph of
 *  an item in the graph.
 */
#define VHGOFFSET( _graph, _item )                              \
    ( (char*)(_item) - (char*)(_graph) )

/*
 *  This macro creates a pointer from an offset (opposite of VHGOFFSET)
 */
#define VHGDEREF( _graph, _offset)                              \
    ((VHGNODELIST*) ( ((char*)_graph) + _offset ))

/*
 *	Basic VHG list macros
 */
#define VHGLIST_EMPTY(_graph, _head)							\
	( ((_head)->succ) == ( VHGOFFSET((_graph), (_head)) ) )


#ifdef __cplusplus
extern "C" {
#endif

extern int		initializeVHG( VERSIONGRAPH*, OID*, VHGNODEFLAGS );
extern void		initializeVHGNode( VERSIONGRAPH*, VHGNODE*, VHGNODEID );
extern int		initializeNewVHGNodes( VERSIONGRAPH*, int);
extern void		initializeVHGList( VERSIONGRAPH*, VHGNODELIST* );
extern void		initializeVHGListElement( VHGNODELISTELEMENT*, VHGPTR );
extern void		listVHGEnq( VERSIONGRAPH*, VHGNODELIST*, VHGNODELISTELEMENT* );
extern VHGNODE*	listVHGDeq( VERSIONGRAPH*, VHGNODELIST* );
extern void		listVHGRemove( VERSIONGRAPH*, VHGNODELISTELEMENT* );
extern int	 	createVHG( int, FID*, OID*, OID*, VHGNODEID* );
extern int	 	createVersion( VERSIONGRAPH*, OID*, VHGNODEID, VHGNODEID* );
extern int		markFrozen( VERSIONGRAPH*, VHGNODEID );
extern int		markDestroyPending( VERSIONGRAPH*, VHGNODEID );
extern int		destroyNode( VERSIONGRAPH*, VHGNODEID, BOOL* );
extern int		findAdjacent( BUFGROUP*, VERSIONGRAPH*, VHGNODEID, LIST*, POOL* );
extern int		findDirectChildren( BUFGROUP*, VERSIONGRAPH*, VHGNODEID, VHGNODEID, LIST*, POOL* );
extern BOOL		workingChildren( VERSIONGRAPH*, VHGNODEID );
extern BOOL		parentDestroyPending( VERSIONGRAPH*, VHGNODEID, OID* );

#ifdef __cplusplus
}
#endif


#endif /* _VERSION_FUNCS_H_ */
