/*
 *   $RCSfile: LG_PrintTstack.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:24 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


#include <stdio.h>
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "io.h"
#include "page.h"
#include "list.h"
#include "object.h"
#include "tid.h"
#include "bf.h"
#include "chunk.h"
#include "bf_macro.h"
#include "lgobject.h"
#include "lg_intfuncs.h"
#include "lg_extfuncs.h"
#include "error.h"

/*
 * Push (slotNo, pid, nodePtr) triple onto stack.
 */


#ifdef DEBUG

 void 
LG_PrintTstack (

	register TSTACK		*tstack 
)
{

	register TSTACKENT	*currentEntry;
	register int		i;


	TRACE(TR_LG, TR_LEVEL_3);

	/*
	 *	Increment the top and check for overflow
	 */
    for (i = tstack->top; i >= 0; i--)	{

		/*
		 *	get a pointer to the current entry
		 */
		currentEntry = &(tstack->stack[i]);

		/*
		 *	print the contents of the top of the stack
		 */
		TRPRINT(TR_LG, TR_LEVEL_3, ("element:%d pid:%d slotIndex:%d dangerFlag:%d dangerCount:%d",
				i, currentEntry->pid.page, currentEntry->slotIndex,
				currentEntry->dangerFlag, currentEntry->dangerCount));
	}
}

#endif
