/*
 *   $RCSfile: LG_RecycleNodeListElements.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:24 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


#include <stdio.h>
#include "checking.h"
#include "ess.h"
#include "list.h"
#include "pool.h"
#include "error.h"
#include "trace.h"
#include "io.h"
#include "object.h"
#include "lock.h"
#include "tid.h"
#include "bf.h"
#include "chunk.h"
#include "lgobject.h"
#include "version_graph.h"
#include "lg_versionfuncs.h"


 void
LG_RecycleNodeListElements (

	register POOL			*head,
	register LIST			*elementList 
)
{
	LGNODELIST	*element;

	TRPRINT(TR_LIST, TR_LEVEL_1, ("head:%x elementList:%x", head, elementList));

	/*
	 *	check the pool magic number
	 */
	CHECK_POOL_MAGIC(head);

	/*
	 *	put each element in the list back into the pool
	 */
	for (element = (LGNODELIST*) listDeq(elementList);
		 element != NULL;
		 element = (LGNODELIST*) listDeq(elementList) ) {

		poolEnq(head, &element->list);
	}
}
