/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "BTREEPAGE.h"
#include "bf_macro.h"
#include "LH_SMOPages.h"


void LH_SMOPages::Insert(PID& pid)
{
	for (int i = 0; i < count; i++)  {
		if (pages[i] == pid)  return;
		}

	pages[count++] = pid;
}

void LH_SMOPages::Delete(PID& pid)
{
	for (int i = 0; i < count; i++)  {
		if (pages[i] == pid) {
			for (int j=i; j<count-1; j++)
				pages[j] = pages[j+1];
			count--;
			return;
			}
		}
}


void LH_SMOPages::Flush()
{
	for (int i = 0; i < count; i++)  {

	/* define the second argument for the server version of bf_FindPage():*/
#ifdef SERVER_MAKE
#	define __SERVERFLAGS__ ,0
#else
#	define __SERVERFLAGS__
#endif
		PAGEHASH* phash = bf_FindPage(& pages[i] __SERVERFLAGS__ );


		if (phash)  {

			ASSERT3(PAGE_IS_DIRTY(phash));

			bf_ForcePage(phash, NOFLAGS);
			}
		}
	count = 0;
}

