/*
 *	$RCSfile: lh_CheckIndex.C,v $
 *	$Revision: 1.1.1.1 $
 *	$Date: 1996/05/04 21:55:25 $
 */
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "BTREEPAGE.h"


int lh_CheckIndex(PID& const dirPid, BUFGROUP* bufGroup)
{
	PageDesc	dirPd;
	LHDIRPAGE*	dirp;

	if (dirPd.Read(bufGroup, dirPid, SH))  {
		return esmFAILURE;
		}

	dirp = dirPd;
	ASSERT1(dirp->SelfID() == dirPid);
	dirp->CheckContent();

	if (dirp->Height()>1) {
		for (int i=0; i < dirp->CurPos(); i++) {
			PID curPid = dirPid;
			curPid.page = dirp->GetEntry(i);
			if(lh_CheckIndex(curPid, bufGroup) != esmNOERROR) {
				return esmFAILURE;
			}
			}
		}
	else {
		for (int i=0; i < dirp->CurPos(); i++) {
			PID pid = dirp->SelfID();
			pid.page = dirp->GetEntry(i);
			if (pid.page==NULLPID) 
				continue;
			PageDesc indPd;
			LHINDPAGE* indp;
			if (indPd.Read(bufGroup, pid, SH))  {
				return esmFAILURE;
				}
		
			indp = indPd;
			ASSERT1(indp->SelfID() == pid);
			indp->CheckContent();

			while (indp->HaveOv()) {
				pid = indp->SelfID();
				pid.page = indp->OvPage();
				indPd.Unfix();
				if (indPd.Read(bufGroup, pid, SH))  {
					return esmFAILURE;
					}
				indp = indPd;
				ASSERT1(indp->SelfID() == pid);
				}
			indPd.Unfix();
			}
		}


	dirPd.Unfix();
	
	return esmNOERROR;
}
