/*
 *	$RCSfile: lh_IsEmpty.C,v $
 *	$Revision: 1.1.1.1 $
 *	$Date: 1996/05/04 21:55:25 $
 */

/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "BTREEPAGE.h"
#include "LHSTACK.h"
#include "LH_Hash.h"
#include "LH_SMOPages.h"


lh_IsEmpty(TID tid, PID& const rootPid, BUFGROUP* bufGroup, BOOL* ret)
{
	LHashStack pl(bufGroup);

	//
	// read in the root directory page
	//
	if (pl.ReadNPush(rootPid, SH))
		return esmFAILURE;

	LHDIRPAGE* rootp = pl.Top();
	if (rootp->Primary() != INIT_PRIMARY || rootp->Load() > .0000001
		|| rootp->Height() > 1) {
		*ret = FALSE;
		return esmNOERROR;
		}

	//
	// examine each index page to make sure all are empty
	//
	PID indPid;
	indPid.volid = rootPid.volid;
	for (int i = 0; i< INIT_PRIMARY; i++) {
		indPid.page = rootp->GetEntry(i);
		if (indPid.page != NULLPID) {
			*ret = FALSE;
			return esmNOERROR;
			}
		}

	*ret = TRUE;
	return esmNOERROR;
}

