/*
 *   $RCSfile: selectReceive.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:28 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "host.h"
#include "trans.h"
#include "bf.h"
#include "lsn.h"
#include "loginfo.h"
#include "serverinfo.h"
#include "link.h"
#include "bitvec.h"
#include "msg_globals.h"
#include "sm_globals.h"
#include "trans_globals.h"
#include "msg_funcs.h"

 int
selectReceive (
	
	register BITVEC	*readyMask 
)
{

	register int	limitIndex;
	register int	currentIndex;
	register BITVEC	*workMask;


	TRACE(TR_MSG, TR_LEVEL_1);

	/*
	 *	get pointers to the globalbit vectors
	 */

	TRPRINT(TR_MSG, TR_LEVEL_2, ("no disk requests ready"));

	/*
	 *	set the mask
	 */
	workMask = readyMask;
	currentIndex = AllIndex;

	/*
	 *	search initially to end of select bits
	 */
	limitIndex = SelectBits;

	/*
	 *	search to see which selector is ready
	 */
	while (currentIndex < limitIndex)	{

		if (bit(workMask, currentIndex))	{

			TRPRINT(TR_MSG, TR_LEVEL_2, ("got index at:%d", currentIndex));

			/*
			 *	set the state for the next receive and return
			 */
			AllIndex = currentIndex + 1;
			TRPRINT(TR_MSG, TR_LEVEL_2, ("setting next all receive to:%d", AllIndex));
			return(currentIndex);
		}

		/*
		 *	increment and check for the end of select bits
		 */
		if (++currentIndex == limitIndex)	{

				currentIndex = AllIndex = 0;
				return(-1);
		}
	}

	/* should never get here */
	return -1; /* to keep compiler quiet */
}

