/*
 *   $RCSfile: sm_PrintPage.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:29 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


#include <stdio.h>
#include "ess.h"
#include "checking.h"
#include "io.h"
#include "page.h"
#include "list.h"
#include "object.h"
#include "tid.h"
#include "bf.h"
#include "lock.h"
#include "chunk.h"
#include "bf_macro.h"
#include "sm_macro.h"
#include "error.h"
#include "trace.h"
#include "scan.h"
#include "load.h"
#include "sm_params.h"
#include "btree.h"
#include "sm_intfuncs.h"
#include "sm_extfuncs.h"


#ifdef DEBUG

 void
sm_PrintPage (

	SLOTTEDPAGE			*pagePtr 
)
{

    register SLOTINDEX	i;
	register SLOTINDEX	slotCount;
	register PAGESLOT	*slotPtr;
	OBJECT				*objectPtr;


	TRACE(TR_SM, TR_LEVEL_1);

	/*
	 *	get the number of slots on the page
	 */
	slotCount = pagePtr->header.slotCount;

	/*
	 *	setup the pointer
	 */
	slotPtr = &(pagePtr->slot[0]);

	/*
	 *	look at all the slots
	 */
	for (i = 0; i < slotCount; i++, slotPtr--)	{

		/*
		 *	check to see if the slot is active
		 */
		if (slotPtr->offset == NIL)	{

			TRPRINT(TR_SM, TR_LEVEL_3, ("slot:%d is inactive", i));

		} else {

			/*
			 *	get a pointer to the object header
			 */
			objectPtr = GETOBJECTPTR(pagePtr, slotPtr);

			/*
			 *	print out the slot and size information
			 */
			TRPRINT(TR_SM, TR_LEVEL_3, ("slot:%d is active - unique:%d offset:%d size:%d",
					i, slotPtr->unique, slotPtr->offset, objectPtr->objectHdr.size));

		}
	}
}

#endif
