/*
 *   $RCSfile: sm_PrintSlotPage.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:29 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


#include <stdio.h>
#include "ess.h"
#include "checking.h"
#include "io.h"
#include "page.h"
#include "list.h"
#include "object.h"
#include "tid.h"
#include "bf.h"
#include "chunk.h"
#include "bf_macro.h"
#include "sm_macro.h"
#include "error.h"
#include "trace.h"
#include "scan.h"
#include "load.h"
#include "sm_params.h"
#include "btree.h"
#include "lock.h"
#include "sm_intfuncs.h"
#include "sm_extfuncs.h"


#ifdef DEBUG
 void
sm_PrintSlotPage (

	register SLOTTEDPAGE	*page 
)
{

	TRACE(TR_SM, TR_LEVEL_3);

	/*
	 *	check to make sure the page magic is correct
	 */
	TRPRINT(TR_SM, TR_LEVEL_3, ("magic: %x", page->header.magic));
	TRPRINT(TR_SM, TR_LEVEL_3, ("largeCount:%d", page->header.largeCount));
	TRPRINT(TR_SM, TR_LEVEL_3, ("neigborPid:%d  %d", page->header.neighborPid.volid,
			page->header.neighborPid.page));
	TRPRINT(TR_SM, TR_LEVEL_3, ("fid:%d  %d", page->header.fid.pid.volid,
			page->header.fid.pid.page));
	TRPRINT(TR_SM, TR_LEVEL_3, ("pid:%d  %d", page->header.pid.volid,
			page->header.pid.page));
	TRPRINT(TR_SM, TR_LEVEL_3, ("freeSlot:%d", page->header.freeSlot));
	TRPRINT(TR_SM, TR_LEVEL_3, ("freeBytes:%d", page->header.freeBytes));
	TRPRINT(TR_SM, TR_LEVEL_3, ("freeStart:%d", page->header.freeStart));
	TRPRINT(TR_SM, TR_LEVEL_3, ("slotCount:%d", page->header.slotCount));
	sm_PrintPage(page);
}

#endif
