/*
 *   $RCSfile: space.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:29 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "list.h"
#include "lock.h"
#include "tid.h"
#include "sm_state.h"
#include "sm_globals.h"
#include "sm_user.h"


int			sm_errno = esmNOERROR;
int			sm_reason = esmNOERROR;	/* reason a transaction was aborted */
int			NumScanDesc = 32;
LIST		ScanDescPool;
LIST		UsedScanDesc;
int			NumLoadDesc = 16;
LIST		LoadDescPool;
LIST		UsedLoadDesc;
BOOL		InternalCall = FALSE; /* used to indicate that a call
									 of an sm_() function is being
									 made from within a storage manager
									 function */

/*
 *	Global area to hold version history graph while working on one
 */
char		*VersionGraphSpace = NULL;
int			VersionGraphSpaceSize = 0;

/*
 *	Error messages are printed here
 */
FILE		*sm_ErrorStream = NULL;

/*
 *	global variables for user transaction macros
 */
jmp_buf		sm_TransJmpBuf;
int			*sm_TransReturnCode;

/*
 *  Default locking modes for files and pages.
 *  Users can set these as desired.
 */
LOCKMODE     sm_DefaultPageLock = SH;
LOCKMODE     sm_DefaultFileLock = NL;

/*
 *	State for an operation
 */
SMSTATE	SM_State;

BOOL          DeallocSmallObjPages = TRUE;

#define	SCANSTRINGLEN 1000
char 		scanErrorString[SCANSTRINGLEN+1];
