/*
 *   $RCSfile: SM_SetState.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:30 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "list.h"
#include "io.h"
#include "page.h"
#include "object.h"
#include "tid.h"
#include "bf.h"
#include "lock.h"
#include "bf_macro.h"
#include "trace.h"
#include "error.h"
#include "scan.h"
#include "load.h"
#include "volume.h"
#include "sm_params.h"
#include "btree.h"
#include "msgdefs.h"
#include "lsn.h"
#include "loginfo.h"
#include "serverinfo.h"
#include "sm_macro.h"
#include "sm_state.h"
#include "file.h"
#include "fi_extfuncs.h"
#include "io_extfuncs.h"
#include "sm_intfuncs.h"
#include "msg_funcs.h"
#include "msg_globals.h"
#include "sm_globals.h"


 int
SM_SetLogServerState (
	GROUPLINK	*groupLink,
	OID			*unused 	
)
{
	FILEINFO	*fileInfo;

	SM_ASSERT(LEVEL_1, (SM_State.serverInfo != NULL));
	SM_ASSERT(LEVEL_1, (groupLink != NULL));

	SM_ASSERT(LEVEL_1, (SM_State.logInfo == &(SM_State.serverInfo->logInfo)));

	SM_State.logLevel = SM_State.defaultLogLevel;

	{
		SLOTTEDPAGE	*page = (SLOTTEDPAGE*) groupLink->bufFrame;
		SM_ASSERT(LEVEL_3, !CHECK_SLOTTED_MAGIC(page));
		/* TODO */

		fileInfo = fi_FindFileInfo(&page->header.fid, TRUE);
		if (fileInfo == NULL) {
			return(esmFAILURE);  /* this should not happen */
		}

		SM_State.logLevel = fileInfo->logLevel;
	}
	return(esmNOERROR);
}

