/*
 *   $RCSfile: beginTrans.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:30 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "pool.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "trans.h"
#include "bf.h"
#include "file.h"
#include "chunk.h"
#include "serverinfo.h"
#include "bf_extfuncs.h"
#include "trans_funcs.h"
#include "msg_funcs.h"
#include "trans_globals.h"
#include "msg_globals.h"


 int
beginTrans (

	SERVERINFO	*serverInfo,
	TID			*tid
)
{
	MESSAGE		message;

	TRACE(TR_TRANS, TR_LEVEL_1);

	message.header.type = BEGIN_TRANS;
	message.header.replyRequested = TRUE;
	message.body.trans.lock_timeout = DefaultLockTimeout;

	/*
	 *	request a transaction id from the server	
	 */
	if (callServer(serverInfo, &message, NULL, 0 ) != esmNOERROR)	{

		return(esmFAILURE);
	}

	if(tid != NULL)
		*tid = message.body.trans.tid;	
	TRPRINT(TR_TRANS, TR_LEVEL_2, ("tid:%d", tid?*tid:0));

	TransRec.clientTransState = T_ACTIVE;

	return esmNOERROR;
}
