/*
 *   $RCSfile: SM_Error.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:30 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "error.h"
#include "list.h"
#include "lock.h"
#include "sm_globals.h"


extern int	sm_errno;
extern int	PrintUser;


 void
SM_Error(

	int		type,
	int		eno,
	char	*file,
	int		line 

)
{

	char	*pointer;
	
	/*
	 *	print an error message
	 */
	if ((type == TYPE_FATAL) || (type == TYPE_CRASH) || (PrintUser))	{
		if (sm_ErrorStream == NULL) sm_ErrorStream = stderr;
		fprintf(sm_ErrorStream, "CLIENT file:%s line:%d errno:%d error id:%s -- %s\n", file, line, eno, errorIdString(eno), errorCodeString(eno));
		fprintf(sm_ErrorStream, "CLIENT aborting; creating core file...\n");
		fflush(sm_ErrorStream);
	}

	sm_errno = eno;

#ifdef DEBUG
	fflush(stdout); /* for tracing */
#endif DEBUG

	/*
	 *	dump only on fatal
	 */
	if (type == TYPE_FATAL)	{

		/*
		 *	reference the null pointer
		 */
		pointer = NULL;
		*pointer = 0;
	}
}
