/*
 *   $RCSfile: listVHGEnq.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:32 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include <stdio.h>
#include "checking.h"
#include "ess.h"
#include "io.h"
#include "object.h"
#include "error.h"
#include "trace.h"
#include "list.h"
#include "pool.h"
#include "bf_external_group.h"
#include "version_graph.h"
#include "version_funcs.h"

 void
listVHGEnq(

	VERSIONGRAPH		*graph,
	VHGNODELIST			*head,
	VHGNODELISTELEMENT	*element 
)
{

    TRPRINT(TR_VHGLIST, TR_LEVEL_1, ("head:%x element:%x", head, element));

    /*
     *  Check to see if the magic number is valid
     */
    CHECK_VHGLIST_MAGIC(head);

    /*
     *  Check to see if the magic number is valid
     */
    CHECK_VHGLIST_MAGIC(element);

    /*
     *  Check to see if the item is already on a list
     */
    if (element->succ != VHGNULLNODE)  {

        /*
         *  This should not happen
         */
        SM_ERROR(TYPE_FATAL, esmINTERNAL);

    } else {

        /*
         *  Put the item last on the list
         */
        element->succ       = VHGOFFSET(graph, head);
        element->pred       = head->pred;
        (VHGDEREF(graph, element->pred))->succ = VHGOFFSET(graph, element);
        head->pred          = VHGOFFSET(graph, element);
    }

}
