/*
 *   $RCSfile: initErrorCodes.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:11 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include <stdio.h>
#include "ess.h"
#include "error.h"


 void
initErrorCodes ()

{

	if (!ErrorBaseInit) {
		/*
		 *	Assign error descriptions arrays to the ErrorBase
		 *	entry corresponding to their error base.
		 */
		ErrorBase[UNIX_ERROR_BASE] 			= UNIX_ErrorInfo;
		ErrorBase[GENERAL_ERROR_BASE]		= GENERAL_ErrorInfo;
		ErrorBase[SM_ERROR_BASE]			= SM_ErrorInfo;
		ErrorBase[BF_ERROR_BASE]			= BF_ErrorInfo;
		ErrorBase[LG_ERROR_BASE]			= LG_ErrorInfo;
		ErrorBase[EH_ERROR_BASE]			= EH_ErrorInfo;
		ErrorBase[FI_ERROR_BASE]			= FI_ErrorInfo;
		ErrorBase[IO_ERROR_BASE]			= IO_ErrorInfo;
		ErrorBase[MSG_ERROR_BASE]			= MSG_ErrorInfo;
		ErrorBase[THREAD_ERROR_BASE]		= THREAD_ErrorInfo;
		ErrorBase[BM_ERROR_BASE]			= BM_ErrorInfo;
		ErrorBase[TRANS_ERROR_BASE]		= TRANS_ErrorInfo;
		ErrorBase[LOCK_ERROR_BASE]		= LM_ErrorInfo;
		ErrorBase[LOG_ERROR_BASE]			= LOG_ErrorInfo;
		ErrorBase[RESOURCE_ERROR_BASE]	= RESOURCE_ErrorInfo;
		ErrorBase[RECOVER_ERROR_BASE]		= RECOVER_ErrorInfo;
		ErrorBase[IM_ERROR_BASE]			= IM_ErrorInfo;
		ErrorBase[OPT_ERROR_BASE]			= OPT_ErrorInfo;
		ErrorBase[DISTR_ERROR_BASE]			= DISTR_ErrorInfo;

		ErrorBaseInit = TRUE;
	} 

	return;
}
