/*
 *   $RCSfile: configOptions.c,v $  
 *   $Revision: 1.2 $  
 *   $Date: 1996/05/04 23:51:45 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

/*
 *  This file contains compile time configuration settings for
 *  the Storage Manager client and server.
 */

/*
 * SM_ConfigFileName contains the complete path name of the default
 * configuration file.  Usually it is in a directory such as
 * /usr/lib/exodus with the name sm_config.
 *
 * If you are setting up the Storage Manager for the first time,
 * you need not alter SM_ConfigFileName yet.  Later, when you 
 * set up a site specific configuration file you can change it.
 */
char	*SM_ConfigFileName = "/usr/local/sm/bin/sm_config";

/*
 * SM_DiskProcessName contains the complete path name of the disk
 * I/O exececutable used by the SM server.  Usually it is in a
 * directory such as /usr/lib/exodus with the name diskrw.
 *
 * If you are setting up the Storage Manager for the first time and
 * just interested in testing it, the set SM_DiskProcessName to
 * SMROOT/bin/diskrw where SMROOT is the complete path to the
 * Storage Manager release.
 */
char	*SM_DiskProcessName = "/usr/local/sm/bin/diskrw";
