/*
 *   $RCSfile: closeLocalDisk.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:56:07 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "disk.h"
#include "queues.h"
#include "diskproc_globals.h"
#include "diskproc_intfuncs.h"
#include "diskproc_extfuncs.h"


extern int		errno;
extern int		Fd;


 void
closeLocalDisk (

	register DISKMSG	*message
)
{

	TRPRINT(TR_DISKRW, TR_LEVEL_1, ("closing disk:%s", DiskName));

	/*
	 *	attempt to open the disk
	 */
	if (close(Fd) < 0)	{

		/*
		 *	reply in the negative
		 */
		message->header.params.out.errno = errno;
		message->diskmagic = DISK_MESSAGE_MAGIC;
		replyDiskMessage(message);
		/* 
		 * process dies whether it's the server or the diskprocess
		 */
		SM_ERROR(TYPE_FATAL, errno);

	} else {

		TRPRINT(TR_DISKRW, TR_LEVEL_1, ("close successful"));

		/*
		 *	reply in the positive
		 */
		message->header.params.out.errno = esmNOERROR;
		message->diskmagic = DISK_MESSAGE_MAGIC;
		replyDiskMessage(message);
	}
#	ifdef DISKPROC_MAKE
	onexit(errno);
#	endif DISKPROC_MAKE
}
