/*
 *   $RCSfile: space.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:56:07 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "disk.h"
#include "volume.h"
#include "queue_consist.h"

#include "queues.h"
#include "diskproc_globals.h"
#include "diskproc_intfuncs.h"
#include "diskproc_extfuncs.h"

int				Socket;				/* for comm with server */
char			*ShmAddress;		/* == ShmAddress in the server */
int				ShmId;				/* == ShmId in the server */
char			*TraceName = "DISKRW";	/* == TraceName in server */
TRACEFLAGS		TraceFlags;			/* == TraceFlags in server */
TRACELEVEL		TraceLevel;			/* == TraceLevel in server */
struct shmid_ds	Shmstruct;			/* used only here, for error checking */
int				Fd;					/* disk device */

char			*DiskName;			/* DiskName in server  */


int				Parent=0;
int				SemId;		/* corresponds to SemId in server */
char			SemNum;		/* ONE BYTE */
int				NumMsgBufs;	/* corresponds to NumMsgBufs in server */
QUEUEPAIR		*DiskQueue; /* the one queue for our disk only */
ProcessIdentity process_identity; /* queues.h */
MUTEX 			*Replies; /* queues.h */

/*
 *	These variables hold info about whether the volume is a
 *	raw device.  If so, a buffer is allocated so that contiguous
 *	pages can be placed into it for faster write performance.
 */
BOOL             RawDev = FALSE;
char             *BlockBuf = NULL;
int              BlockBufSize = 0;

