/*
 *   $RCSfile: usage.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:56:07 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include <stdio.h>
#include "ess.h"
#include "io.h"

 void
usage(
	char	*programName,
	BOOL 	full 
)
{

	printf("Usage: %s [-s portname] [-n portnum] [-e errorfile] [-B buffer_size] [-L log_volume_name] [-r] [-f] [-h] [-p] [-b] [-l] [-S]\n", programName);
	if (full) {

		printf("[-s portname] indicates the symbolic name of the port\n");
		printf("    under which the sm_server will register.\n");
		printf("[-n portnum] indicates the numeric name of the port,\n");
		printf("    for unregistered ports (names not in /etc/services).\n");
		printf("    If neither -s nor -n is given, `exodussm' will be used.\n");
		printf("[-e errorfile] errorfile is the name of the file that\n");
		printf("    will receive error messages (default is standard error.\n");
		printf("[-B buffer_size] number of %d byte buffer pool pages\n", MIN_PAGESIZE);
		printf("[-L log_volume_name] name of the volume containing the log\n");
		printf("[-r] regenerate the log instead of performing\n");
		printf("    recovery on it (use after log disk is formatted).\n");
		printf("[-f] force the -r option instead of verifying with user\n");
		printf("[-p] print progress with log and checkpoints\n");
		printf("[-b] server is to be run in the background,\n");
		printf("    so standard input is not monitored\n");
		printf("[-l] turn off preflushing of log pages\n");
		printf("    (for testing use only)\n");
		printf("[-S] additional server statistics are printed periodically\n");
		printf("    (for testing use only)\n");
	}

	return;
}
