/*
 *   $RCSfile: bm_CheckSet.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:36 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "semaphore.h"
#include "link.h"
#include "latch.h"
#include "lsn.h"
#include "bf.h"
#include "volume.h"
#include "bitmap.h"
#include "bm_intfuncs.h"
#include "bm_extfuncs.h"


 int
bm_CheckSet (

	register UFOUR		*map,
	register FOUR		bit 
)
{

	register UFOUR		word;
	register UFOUR		mask;


	TRPRINT(TR_BITMAP, TR_LEVEL_1, ("checking bit:%d", bit));

	/*
	 *	get the word within the map
	 */
	word = BIT_TO_WORD(bit);
	TRPRINT(TR_BITMAP, TR_LEVEL_2, ("word:%d bit in word:%d", word, BIT_IN_WORD(bit)));

	/*
	 *	set the mask
	 */
	mask = ((ulong) MSB_MASK) >> BIT_IN_WORD(bit);
	TRPRINT(TR_BITMAP, TR_LEVEL_2, ("mask:%8.8x", mask));

	/*
	 *	set the bit
	 */
	TRPRINT(TR_BITMAP, TR_LEVEL_2, ("map word:%8.8x", map[word]));
	return(map[word] & mask);
}
