/*
 *   $RCSfile: cl_SetCLR.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:37 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "BTREEPAGE.h"
#include "bitvec.h"
#include "msg_funcs.h"
#include "cl_funcs.h"

 void
cl_SetCLR (

	register MESSAGE	*message,
	register LINK		*unused 
)
{
	register TRANSREC   *transRec;
    /*
     *  register thread with transaction, TRUE => writing log
     */
    if ((transRec = registerTrans(message->header.params.in.tid, TRUE)) == NULL) {

        SM_ERROR(TYPE_USER, esmBADTRANSID);
        reply(esmFAILURE, Active->errno, 1, TRUE);
    }

	if (BT_SetCLR(message->header.params.in.tid))  {
		reply(esmFAILURE, Active->errno, 1, TRUE);
		}

	reply(esmNOERROR, esmNOERROR, 1, TRUE);
}
