/*
 *   $RCSfile: cl_Statistics.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:37 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "pool.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "semaphore.h"
#include "link.h"
#include "lsn.h"
#include "latch.h"
#include "bf.h"
#include "bitvec.h"
#include "adminmsg.h"
#include "msg_funcs.h"
#include "cl_funcs.h"
#include "admin_funcs.h"
#include "thread_funcs.h"
#include "thread_globals.h"
#include "admin_globals.h"


extern int		errno;


 void
cl_Statistics (

	register MESSAGE	*message,
	register LINK		*unused 
)
{

	TRPRINT(TR_CL, TR_LEVEL_1, ("gathering stats"));

	/*
	 *	Validate that the client has permission to request
	 *	statistics.
	 */
	/*
	printf("TODO: cl_Statistics should validate permissions\n");
	*/

	/*
	 *	Collect the stats that must be computed
	 */
	admin_CollectStats();

	/*
	 *	Set up the return of the stats structure, and then return it
	 */
	Active->iovec[1].iov_base = (char*)&ServerStats;
	Active->iovec[1].iov_len = sizeof(ServerStats);
	reply(esmNOERROR, esmNOERROR, 2, FALSE);

	/*
	 *	Clear any stats if reqeusted.  This must be done
	 *	after the stats have been returned.
	 */
	if (message->body.stats.flags & STAT_CLEAR) {
		admin_ClearStats();
	}

	threadRestart();
}
