/*
 *   $RCSfile: space.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:38 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "latch.h"
#include "semaphore.h"
#include "link.h"
#include "lsn.h"
#include "bf.h"
#include "file.h"
#include "log.h"
#include "pool.h"
#include "volume.h"
#include "logrecs.h"
#include "trans.h"
#include "openlog.h"
#include "bitmap.h"


char		*TraceName = "SERVER";
int			PrintProgress = 0;
BOOL		RunInBackground = FALSE;
FILE		*sm_ErrorStream;
BOOL        ShutdownAfterRecovery = FALSE;

/*
 *	Debugging variables
 */

/* 
 *	Common
 */
ONE				*debugOnePtr;
TWO				*debugTwoPtr;
FOUR			*debugFourPtr;
char			*debugCharPtr;

ONE				debugOne;
TWO				debugTwo;
FOUR			debugFour;
char			debugChar;
PID				debugPid;

/*
 *	Thread related
 */
TCB				*debugTcb;
FOUR			debugThreadId;

/*
 *	Page related
 */
SLOTTEDPAGE 	*debugSlottedPage;
SLOTTEDHEADER	*debugSlottedHeader;
OBJHDR			*debugObjHdr;
LGNODEHDR		*debugLgNodeHdr;
NODEPAGE		*debugFileNodePage;
LGDATAPAGE		*debugLgDataPage;
BITMAPPAGE		*debugBitMapPage;

/*
 *	Log related
 */
LOGRECORDHDR	*debugLogRecordHdr;
LOGPAGEHDR		*debugLogPageHdr;

/* 
 *	Large obj related
 */
LGSLOT			*debugLgSlot;

TRANSREC		*debugTransRec;

OID				*debugOid;

VOLREC			*debugVolRec;
VOLHDR			*debugVolHdr;

/*
 *	Message related
 */
MESSAGE			*debugMessage;
MSGBODY			*debugMsgBody;
MSGHDR			*debugMsgHdr;
