/*
 *   $RCSfile: initVolume.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:38 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "semaphore.h"
#include "latch.h"
#include "link.h"
#include "bf.h"
#include "volume.h"
#include "threadstate.h"
#include "disk.h"
#include "disk_funcs.h"
#include "disk_globals.h"


 void
initVolume ()

{

	register VOLINFO	*volInfo;
	register int		i;


	TRACE(TR_DISK, TR_LEVEL_1);

	/*
	 *	attempt to allocate space for the messages
	 */
	if ((volInfo = (VOLINFO *) malloc(sizeof(VOLINFO) * NumVolInfo)) == NULL)	{

		SM_ERROR(TYPE_FATAL, esmMALLOCFAILED);
	}

	/*
	 *	copy the pointer into global space
	 */
	VolInfo = volInfo;

	/*
	 *	initialize the lists
	 */
	initializeList( &VolInfoPool );

	/*
	 *	initialize the links
	 */
	for (i = 0; i < NumVolInfo; i++, volInfo++)	{

		initializeListElement( &(volInfo->linkList), (char *) volInfo );
		initializeListElement( &(volInfo->volList), (char *) volInfo );
		listEnq( &VolInfoPool, &(volInfo->linkList) );
	}
}
