/*
 *   $RCSfile: removeIpcs.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:40 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "queue_consist.h"

#if defined(mips) || defined(_AIX)
#ifndef __cplusplus
	union semun {
		int val;
	};
#endif /*!__cplusplus*/
#endif /* defined(mips) || defined(_AIX) */

#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "list.h"
#include "error.h"
#include "tid.h"
#include "pool.h"
#include "io.h"
#include "bitvec.h"
#include "lock.h"
#include "msgdefs.h"
#include "disk.h"
#include "thread.h"
#include "semaphore.h"
#include "latch.h"
#include "bf.h"
#include "link.h"
#include "volume.h"
#include "trace.h"
#include "msgvector.h"
#include "disk_funcs.h"
#include "disk_globals.h"
#include "io_globals.h"
#include "msg_globals.h"
#include "sharedmem_globals.h"
#include "queue_globals.h"

void
removeIpcs()
{

	/* Don't call SM_ERROR - we could loop */

#ifdef hpux
    int x = 0;
#else
	union semun x;
	x.val = 0;
#endif 
	if(SemId>=0) {
		if(semctl(SemId,0,IPC_RMID, x) < 0 ) {
			fprintf(stderr, "Can't remove semaphore with id %d.\n", SemId);
			fprintf(stderr, "Please remove manually.  See ipcrm(1).\n");
			/* don't exit */
		}
	}
	if(ShmId >= 0) {
		if( shmctl ( ShmId,IPC_RMID, 0 ) < 0 ) {
			fprintf(stderr, 
				"Can't remove shared-memory segment with id %d.", ShmId);
			fprintf(stderr, "Please remove manually.  See ipcrm(1).\n");
			/* don't exit */
		}
	}
}
