/*
 *   $RCSfile: space.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:38 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "disk.h"
#include "thread.h"
#include "semaphore.h"
#include "latch.h"
#include "link.h"
#include "lsn.h"
#include "bf.h"
#include "volume.h"
#include "disk_globals.h"
#include "queue_consist.h"


VOLINFO		*VolInfo;
LIST		VolInfoPool;
int			NumVolInfo = 20;
char		*DiskProcName = NULL;

key_t		SemKey = 0xdecaf000; 	/* queue_globals.h */
int			SemId= -1;				/* queue_globals.h */
int			QPairSize = sizeof(QUEUEPAIR);	/* queue_globals.h */
DISKMSG		*DiskMessages;			/* queue_globals.h */

char		*ShmDiskMessages; /* sharedmem_globals.h */
char		*ShmDiskQueues; /* sharedmem_globals.h */
char		*ShmReplies; /* sharedmem_globals.h */

ProcessIdentity	process_identity; /* queues.h */
MUTEX			*Replies; 		/* queues.h */

#ifdef PROFIL
BOOL		HasProfDir;
#endif PROFIL

/*
 *  This stuff comes from the diskproc/space.c, and is needed
 *  to make the "fast" path stuff work in the server.
 *  The diskproc code assumes one global copy. 
 *  We fill in this copy when we (re-)start the "fast" path.
 */
int             Fd;                 	/* disk device */
char            DiskNameSpace[DEVNAMEMAX];	
char            *DiskName = DiskNameSpace;	
int				NumClients = 0;			/* disk_globals.h */
int				NumActiveClients = 0;	/* disk_globals.h */
