/*
 *   $RCSfile: space.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:40 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "pool.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "semaphore.h"
#include "link.h"
#include "lsn.h"
#include "latch.h"
#include "bf.h"
#include "volume.h"
#include "trans.h"
#include "trans_intfuncs.h"
#include "trans_extfuncs.h"
#include "trans_globals.h"
#include "distr.h"


POOL			GtidRecPool;
int				NumGtidRecs = 8;
GTIDREC			*GtidRecPtr;

POOL			ServerTidInfoPool;
int				NumServerTidInfos = 32;
SERVERTIDINFO	*ServerTidInfoPtr;

/*
 * coord thread waits on this list
 */
LIST			CoordWaitList;

/*
 *	The list of distributed transactions for which this server 
 *	is the coordinator
 */
LIST			CoordDistrTransList;
int				numActiveCoordDistrTrans = 0;
int				numPrevActiveCoordDistrTrans = 0;

/*
 *	The list of distributed transactions for which this server 
 *	is a participant but not the coordinator
 *	- used during recovery
 */
LIST			ServerDistrTransList;
int				numActiveServerDistrTrans = 0;

/*
 *  All volumes mounted by transactions in the prepared state 
 *	at the time of a crash, and the count 
 */
VOLIDNAME   *preparedTransVolumes = NULL;
UFOUR       preparedTransVolumeCount = 0;

VOTE		DebugDistrVote = YESVOTE;
int			DebugCrashLoc = 0; /* do not crash */
