/*
 *   $RCSfile: fi_PrintNode.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:42 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "error.h"
#include "trace.h"
#include "io.h"
#include "page.h"
#include "list.h"
#include "tid.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "semaphore.h"
#include "latch.h"
#include "link.h"
#include "lsn.h"
#include "bf.h"
#include "file.h"
#include "fi_macro.h"
#include "consist.h"
#include "volume.h"
#include "fi_intfuncs.h"
#include "fi_extfuncs.h"


#ifdef DEBUG

 void
fi_PrintNode(

    NODEPAGE			*nodePage 
)
{

    register TREEDATA	*pageArray;
	register FOUR		nodeCount;
	register int		nodeType;
	register int		i;


	TRACE(TR_FI, TR_LEVEL_1);

    /*
     *	Initialize array pointer, # of keys, flag 
     */
    pageArray = &(nodePage->contents);
    nodeCount = nodePage->header.nodeCount;
	nodeType  = nodePage->header.nodeType;

	/*
	 *	print the type of the node
	 */
	TRPRINT(TR_FI, TR_LEVEL_3, ("firstLogicalNode:%d", nodePage->header.firstLogicalNode));
	TRPRINT(TR_FI, TR_LEVEL_3, ("lastLogicalNode:%d", nodePage->header.lastLogicalNode));
	TRPRINT(TR_FI, TR_LEVEL_3, ("node type:%d", nodeType));	
	TRPRINT(TR_FI, TR_LEVEL_3, ("node count:%d", nodeCount));

	/*
	 *	print the contents of the node
	 */
	if (FI_NotLeaf(nodeType))	{

		/*
		 *	print the contents
		 */
		for (i = 0; i < nodeCount; i++)	{

			TRPRINT(TR_FI, TR_LEVEL_3, ("ptr:%d", pageArray->keyPtr[i].pagePtr));
			TRPRINT(TR_FI, TR_LEVEL_3, ("key:%d", pageArray->keyPtr[i].key));
		}

	} else {
		
		/*
		 *	print the contents
		 */
		for (i = 0; i < nodeCount; i++)	{

			TRPRINT(TR_FI, TR_LEVEL_3, ("key:%d",
					pageArray->keyPid.allKeys[i].key & LARGEMASK));
		}
	}
}

#endif
