#ifndef __BF_EXTFUNCS_H__
#define __BF_EXTFUNCS_H__
/*
 *   $RCSfile: bf_extfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:42 $      
 */ 

/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "forward.h"
#include "volume.h"

BEGIN_EXTERNC

extern int			bf_CloseGroup (BUFGROUP *);
extern void			bf_DiscardPage (BUFGROUP *, GROUPLINK *);
extern int			bf_DismountVolume (VOLREC *, BOOL);
extern int			bf_FlushVolume (VOLID);
extern void			bf_ForcePage (PAGEHASH *, FLAGS);
extern void			bf_ForcePageList (PAGEHASH **, int, FLAGS);
extern void			bf_FreeTempPage (GROUPLINK *);
extern void			bf_FreeUnfixed (BUFGROUP *);
extern GROUPLINK	*bf_GetPage (BUFGROUP *, const PID *, FLAGS, PAGE2SIZE);
extern GROUPLINK	*bf_GetPageBuf (BUFGROUP *, PAGE2SIZE);
extern GROUPLINK	*bf_GetTempPage (PAGE2SIZE);
extern int          bf_ConvertTempToRealPage (BUFGROUP *, GROUPLINK*, PID *, FLAGS);
extern int			bf_IncreaseGroupSize (BUFGROUP *, int, FLAGS);
extern void			bf_Initialize (void);
extern void			bf_InvalidatePage (PID *);
extern BUFGROUP		*bf_OpenGroup (int, int, FLAGS);
#ifdef DEBUG
	extern void			bf_PrintFixed (BUFGROUP *);
#else
/* define away calls */
#define bf_PrintFixed(arg)
#endif DEBUG

extern GROUPLINK	*bf_ReadPage (BUFGROUP *, const PID *, PAGE2SIZE, FLAGS);
extern PAGEHASH		*bf_FindPage (const PID *, FLAGS);
extern void			bf_UnfixPage (GROUPLINK *, int, BOOL);
extern BOOL			bf_CheckFixed (PAGEHASH*);
extern void			bf_CleanPage (PAGEHASH *);
extern int			bf_OpenServerGroups (int, int);
extern LRCCACHEENTRY *bf_FindCacheEntry (PID *);
extern LRC*         bf_lrcLoc(PAGEHASH *);
extern void         bf_ForEachPageInHashTable( void *func, void *arg );



END_EXTERNC

#endif __BF_EXTFUNCS_H__
