/*
 *   $RCSfile: bf_intfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:42 $      
 */ 
#ifndef __BF_INTFUNCS_H__
#define __BF_INTFUNCS_H__
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#ifdef __cplusplus
extern "C" {
#endif

extern GROUPLINK	*BF_FindBufGroup (PAGEHASH *, BUFGROUP *);
#ifdef DEBUG
	extern void			BF_AuditGroup (BUFGROUP *);
#endif
extern BUFINFO		*BF_FindFreeSlot (int);
extern PAGEHASH		*BF_FindHashEntry (const PID *);
extern PAGEHASH		*BF_NewPageHash ();
extern void			BF_DiscardPageHash (PAGEHASH *);
extern PAGEHASH		*BF_FindPage (BUFGROUP *, const PID *, FLAGS, GROUPLINK **);
extern void			BF_FreeHashEntry (PAGEHASH *, int); 
extern GROUPLINK	*BF_GetLarger (int);
extern GROUPLINK	*BF_GetSmaller (unsigned);
extern void			BF_AssertPageHashTableEmpty(void);
extern void			BF_DeleteHashTable(void);
extern void			BF_RemovePageFromHT(PAGEHASH *);
extern int			BF_InitBuffers (void);
extern int			BF_InitPageHash (void);
extern void			BF_InitializeGroups (void);
extern void			BF_InitializeSpace (void);
extern void			BF_InsertHashEntry (PAGEHASH *, const PID *, PAGETYPE);
extern void			BF_InvalidatePage (PAGEHASH *, FLAGS);
#ifdef DEBUG
	extern void			BF_ReplacePolicy (BUFGROUP *, LIST *, int);
#endif
extern void			BF_SetSlot (BUFINFO *, int, PAGEHASH *);
extern int			BF_Swap (BUFGROUP *, int);
extern int			BF_SwapAll (BUFGROUP *);
extern BUFGROUP		*bf_AllocBufGroup (POOL *);
extern GROUPLINK	*bf_AllocGroupLink (POOL *);
extern PAGEHASH		*bf_AllocPageHash (POOL *);
extern void			BF_FreePage (BUFGROUP *, GROUPLINK *);
extern void			BF_InitializeSharedMemory (int);
extern void 		BF_CacheLRCInfo ( PAGEHASH	*);
extern void 		BF_FlushLRCCache( VOLID );

#ifdef __cplusplus
}
#endif


#ifndef DEBUG
#define BF_AuditGroup(_bufGroup)
#endif
#endif __BF_INTFUNCS_H__
