/*
 *   $RCSfile: cl_funcs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:42 $      
 */ 
#ifndef __CL_FUNCS_H__
#define __CL_FUNCS_H__
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
BEGIN_EXTERNC


extern void		cl_CreateFile (MESSAGE *, LINK *);
extern void		cl_DestroyFile (MESSAGE *, LINK *);
extern void		cl_FirstLogicalPage (MESSAGE *, LINK *);
extern void		cl_FirstPhysicalPage (MESSAGE *, LINK *);
extern void		cl_LastPhysicalPage (MESSAGE *, LINK *);
extern void 	cl_LastLogicalPage (MESSAGE *, LINK *);
extern void		cl_LockFile (MESSAGE *, LINK *);
extern void		cl_MarkPage (MESSAGE *, LINK *);
extern void		cl_NeighborPage (MESSAGE *, LINK *);
extern void		cl_UnlockPage (MESSAGE *, LINK *);
extern void 	cl_AllocPages (MESSAGE *, LINK *);
extern void		cl_CheckBitmap (MESSAGE *, LINK *);
extern void		cl_DeallocPages (MESSAGE *, LINK *);
extern void		cl_GetRootEntry (MESSAGE *, LINK *);
extern void		cl_GetUnique (MESSAGE *, LINK *);
extern void		cl_LockPage (MESSAGE *, LINK *);
extern void		cl_ReadPage (MESSAGE *, LINK *);
extern void		cl_SetRootEntry (MESSAGE *, LINK *);
extern void		cl_RemoveRootEntry (MESSAGE *, LINK *);
extern void		cl_WritePage (MESSAGE *, LINK *);
extern void     cl_TestNullRpc (MESSAGE *, LINK *);
extern void     cl_TestPageRpc (MESSAGE *, LINK *);
extern void     cl_TestPageSend (MESSAGE *, LINK *);
extern void		cl_WriteLogPage (MESSAGE *, LINK *);
extern void		cl_InitClient (MESSAGE *, LINK *);
extern void		cl_UnlockPage (MESSAGE *, LINK *);
extern void		cl_UnlockFile (MESSAGE *, LINK *);
extern void		cl_QueryPage (MESSAGE *, LINK *);
extern void		cl_SetCLR (MESSAGE *, LINK *);
extern void		cl_SetAnchor(MESSAGE *, LINK *);
extern void		cl_ExternalAbort (MESSAGE *, LINK *);
extern void		cl_SyncTransaction (MESSAGE *, LINK *);
extern void		cl_ExternalBegin (MESSAGE *, LINK *);
extern void		cl_ExternalCommit (MESSAGE *, LINK *);
#ifdef JUNK
extern void     cl_StatVolume (MESSAGE *, LINK *);
extern void     cl_FormatVolume (MESSAGE *, LINK *);
#endif JUNK
extern void     cl_DismountVolume (MESSAGE *, LINK *);
extern void     cl_MountVolume (MESSAGE *, LINK *);
extern void     cl_ShutServer (MESSAGE *, LINK *);
extern void		cl_CloseResource (MESSAGE *, LINK *);
extern void		cl_TakeCheckpoint (MESSAGE *, LINK *);
extern void		cl_ChangeCheckpointFreq (MESSAGE *, LINK *);
extern void		cl_Statistics (MESSAGE *, LINK *);
extern void		cl_ClientLogOff (MESSAGE *, LINK *);

extern void		cl_MonDump(MESSAGE *, LINK *);
extern void		cl_ResetRusage(MESSAGE *, LINK *);
extern void		cl_GetRusage(MESSAGE *, LINK *);
extern void		cl_FileNumPages(MESSAGE*, LINK*);

extern void		cl_ExternalCommand (MESSAGE *, LINK *);
extern void		cl_ExternalContinue2PC (MESSAGE *, LINK *);
extern void		cl_ExternalEnter2PC (MESSAGE *, LINK *);
extern void		cl_ExternalPrepare (MESSAGE *, LINK *);
extern void		cl_ExternalRecover2PC (MESSAGE *, LINK *);
extern void		cl_DebugSetVar (MESSAGE *, LINK *);
extern void		cl_NoSuchCommand (MESSAGE *, LINK *);

extern void		cl_AddVolume (MESSAGE *, LINK *);
extern void		cl_RemoveVolume (MESSAGE *, LINK *);

END_EXTERNC


/* for use in cl_ReadPage, cl_NeighborPage: */
#define LRC_GEQ(lrcA, lrcB) \
	( ( (lrcA).wrapCount > (lrcB)->wrapCount )      || \
	  (	((lrcA).wrapCount == (lrcB)->wrapCount) &&  \
	    ((lrcA).count     >= (lrcB)->count) ) ) 

#endif __CL_FUNCS_H__

