/*
 *   $RCSfile: consist.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:42 $      
 */ 
#ifndef __CONSIST_H__
#define __CONSIST_H__
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
/*
 *	define a structure thats hung off the lock data structure
 */
typedef struct	{

	LISTELEMENT		lockHeaderList;
	PFI				deallocFunc;
	SHORTPID		linkPid;
	FLAGS			flags;
	MAGIC			magic;

} LINKCONSISTREC;


/*
 *	define the lock entry structure magic number
 */
#define LINKCONSISTREC_MAGIC	0x12decdf8


/*
 *	define the types of link consistency
 */
#define LOGICAL_LINK	0x1
#define PHYSICAL_LINK	0x2


#if MAGIC_CHECKING IS_ENABLED


#define INIT_LINKCONSISTREC_MAGIC(_linkConsistRec)				\
																\
	(_linkConsistRec)->magic = LINKCONSISTREC_MAGIC;


#define CHECK_LINKCONSISTREC_MAGIC(_linkConsistRec)				\
																\
	if ((_linkConsistRec)->magic != LINKCONSISTREC_MAGIC)	{	\
																\
		SM_ERROR(TYPE_FATAL, esmINTERNAL);						\
	}


#else 


#define INIT_LINKCONSISTREC_MAGIC(_linkConsistRec)

#define CHECK_LINKCONSISTREC_MAGIC(_linkConsistRec)


#endif
#endif __CONSIST_H__
