/*
 *   $RCSfile: disk_funcs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:42 $      
 */ 
#ifndef __DISK_FUNCS_H__
#define __DISK_FUNCS_H__

/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#ifdef __cplusplus
extern "C" {
#endif


extern void		getMutex (MUTEX *);
extern void		giveMutex (MUTEX *);

#ifdef DEBUG
extern void		dump_spin ();
#endif DEBUG

#ifndef DISKPROC_MAKE
extern int		tryMutex (MUTEX *);
extern void		initializeQueues ();
extern void 	diskReceiveQ (QUEUEPAIR	*qp, BOOL);
extern	int 	dequeueFrom( QUEUEPAIR 	*q, ShmOffset 	*result);
extern int		selectDisk (void);
#endif DISKPROC_MAKE

#ifndef DISKPROC_MAKE
extern int		callDisk (VOLREC *, DISKMSG *);
extern int		closeDisk (VOLREC *);
extern int		fsyncDisk (VOLREC *);
extern void		diskReceive (LINK *);
extern int 		forkDiskProc ( VOLREC * );
extern void 	killDiskProcs ( );
extern	void	removeIpcs (void);
extern	BOOL 	fastPath (VOLREC *volRec, DISKMSG *message);
extern void		freeDiskLink (LINK *, int, int);
extern void		initVolume (void);
extern int		linkVolume (LINK *, VOLREC *);
extern BOOL		openDisk (const char *const, const BOOL, VOLREC *const);
extern void		unlinkVolume (LINK *, VOLREC *);
#endif DISKPROC_MAKE

#ifdef __cplusplus
}
#endif
#endif __DISK_FUNCS_H__
