/*
 *   $RCSfile: fi_extfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:44 $      
 */ 
#ifndef __FI_EXTFUNCS_H__
#define __FI_EXTFUNCS_H__

/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#ifdef __cplusplus
extern "C" {
#endif

extern int			fi_CheckPage (BUFGROUP *, PID *, SHORTPID, BOOL *);
extern int			fi_CreateFile (VOLID, BUFGROUP *, PID *, FID *, FLAGS);
extern int			fi_DeletePage (BUFGROUP *, FID *, SHORTPID, LSNOFFSET);
extern int			fi_DestroyFile (BUFGROUP *, PID *, LIST *, BOOL, BOOL);
extern int			fi_NumPages (BUFGROUP*, PID*, int*);
extern void			fi_DoLinkConsist (PID *, PAGEHASH *, SLOTTEDPAGE *);
extern int			fi_FirstLogicalPage (BUFGROUP *, FID *, PID *);
extern int			fi_FirstPhysicalPage (BUFGROUP *, PID *, SHORTPID *, TREEDATA *, int *);
extern void			fi_FreeLinkConsist (LINKCONSISTREC *);
extern void			fi_Initialize (void);
extern int			fi_InsertPage (BUFGROUP *, FID *, SHORTPID, BOOL, SHORTPID *);
extern int			fi_LastLogicalPage (BUFGROUP *, FID *, PID *);
extern int			fi_LastPhysicalPage (BUFGROUP *, PID *, SHORTPID *, TREEDATA *, int *);
extern int			fi_MarkPage (BUFGROUP *, PID *, SHORTPID);
extern int			fi_NeighborPage (BUFGROUP *, PID *, SHORTPID, SHORTPID *, int, TREEDATA *, int *);
#ifdef DEBUG
extern void			fi_PrintNode (NODEPAGE *);
#endif
extern int			fi_SetLinkConsist (FLAGS, PID *, SHORTPID);
extern int			fi_RecordFileForDestruction(FID *);
extern int			fi_ValidateFid(BUFGROUP *, FID *);

#ifdef __cplusplus
}
#endif
#endif __FI_EXTFUNCS_H__
