/*
 * $RCSfile: fi_intfuncs.h,v $
 * $Revision: 1.1.1.1 $
 * $Date: 1996/05/04 21:55:44 $
 */
#ifndef __FI_INTFUNCS_H__
#define __FI_INTFUNCS_H__

/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#ifdef __cplusplus
extern "C" {
#endif


extern PAGESTACK	*FI_AllocStack (BOOL);
extern int			FI_CheckFull (PID *, BUFGROUP *, PAGESTACK *, GROUPLINK *, PID *);
extern void			FI_DeleteFromArray (NODEPAGE *, FOUR, SHORTPID);
extern void			FI_FreeStack (PAGESTACK *);
extern int			FI_GetAfter (BUFGROUP *, VOLID, PAGESTACK *, SHORTPID *, TREEDATA *, int *);
extern int			FI_GetBefore (BUFGROUP *, VOLID, PAGESTACK *, SHORTPID *, TREEDATA *, int *);
extern void			FI_InitLinkConsistRec (void);
extern void			FI_InitStack (void);
extern int			FI_InsertSearch (BUFGROUP *, PID *, SHORTPID,
									 PAGESTACK *, GROUPLINK **, int *);
extern void			FI_InsertToArray (NODEPAGE *, FOUR, SHORTPID, SHORTPID, BOOL);
extern STACKNODE	*FI_PopStack (PAGESTACK *);
extern STACKNODE	*FI_PushStack (PAGESTACK *, SHORTPID, NODEPAGE *,
								   GROUPLINK *, FOUR, FLAGS);
extern int			FI_SearchNode (BUFGROUP *, PID *, SHORTPID, PAGESTACK *,
								   SHORTPID *, GROUPLINK **, FOUR *);
extern int			FI_SplitNode (PID *, BUFGROUP *, PAGESTACK *, GROUPLINK *, PID *);
extern void			FI_UnfixStack (PAGESTACK *, BOOL);
extern int			FI_LogFileCreateDone (FID *, LSNOFFSET);
extern int			FI_LogKeyInsert (PID *, FOUR, SHORTPID, PAGEHASH *, BOOL);
extern int			FI_LogKeyInsertDone (FID *, SHORTPID, LSNOFFSET);
extern int			FI_LogRootFormat (PID *, PAGEHASH *);
extern int			FI_LogPageSplit (VOLID, GROUPLINK *, GROUPLINK *,
									 GROUPLINK *, LSNOFFSET);
extern int			FI_LogLargeObjOnPage (PID *, FOUR, SHORTPID, PAGEHASH *);

#ifdef __cplusplus
}
#endif
#endif __FI_INTFUNCS_H__
