/*
 *   $RCSfile: io_extfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:45 $      
 */ 
#ifndef __IO_EXTFUNCS_H__
#define __IO_EXTFUNCS_H__


/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "init_funcs.h"

BEGIN_EXTERNC

extern  int		io_AllocPages (VOLREC *, PAGE2SIZE, int, PID *, PID []);
extern  int		io_CheckBitmap (PID *, int, BOOL *);
extern  int		io_Checker (VOLREC *);
extern  void	io_ClearStat (void);
extern  int		io_DeallocPages (PAGE2SIZE, int, PID [], LIST *, BOOL, BOOL);
extern  int		io_FakeDeallocPages (PAGE2SIZE, int, PID [], LIST *, int);
extern  int		io_ReallocPages (PAGE2SIZE, int, PID [], LIST *);
extern  int		io_DismountVolume (VOLREC *, BOOL);
extern  int		io_Final (void);
extern  void	io_ClearStat (void);
extern  int		io_FormatVolume (VOLREC *, VOLNAMEREC *, int, int, int, int, PAGE2SIZE,FLAGS);
extern  int		io_GetRootEntry (VOLREC *, char *, char *, int *);
extern  int		io_GetUnique (PID *, UNIQUE *, int);
extern  int		io_Init ();
extern  int		io_MarkPage (VOLREC *, PID *, int, BOOL);
extern  VOLREC	*io_MountVolume (VOLID, BOOL);
extern  VOLREC	*io_MountLogVolume (VOLID);
extern  int		io_ReadPage (const PID *, char *, PAGE2SIZE);
extern  int		io_SetRootEntry (VOLREC *, char *, char *, int);
extern  int		io_RemoveRootEntry (VOLREC *, char *);
extern  int		io_WritePage (PID *, char *, PAGE2SIZE);
extern  int		io_WritePageList (PID **, char **, PAGE2SIZE*, int);
extern  int		io_CheckAllVolumes ();
extern  char*	io_AllocPageDeallocInfo (POOL*);
extern  char*	io_AllocFileDeallocInfo (POOL*);
extern  void	io_ChangeVolFreePages (VOLREC *, int);
extern  int		io_SyncUnixFileVolumes ();
extern  int		io_SyncTransVolumes (LIST*);
extern  int		io_RemoveVolumeName( VOLID );
extern  void	io_GetVolIds( void );
extern  void 	initializeVolNameTable(void);
extern  int 	io_NumOpenVolumes();


	/* TODO: replace the next two funcs with
		extern  VOLREC	*io_FindVolRec (VOLID, BOOL updatecache = TRUE, LINK *link=0)
	* when the entire SM is compiled with C++
	*/
extern  VOLREC	*io_FindVolRec (VOLID); 
extern  VOLREC	*io_FindVolumeIdWithLink (VOLID, LINK *);

extern  VOLNAMEREC	*io_FindVolNameById (VOLID);
extern  VOLNAMEREC	*io_FindVolName (const char *);
extern  VOLNAMEREC	*io_GetVolNameRec (const char *, VOLID, const char *const); 
extern	void 		io_RecycleVolNameRec (VOLNAMEREC *volNameRec);

extern void 	ForEachVolume(int , void *, 
#ifdef __cplusplus
		void *arg1=(void *)0, void *arg2=(void *)0, void *arg3=(void *)0
#else __cplusplus
		void *, void *, void *
#endif __cplusplus
	);

extern void 	ForEachVolumeNameRec(int , void *, 
#ifdef __cplusplus
		void *arg1=(void *)0, void *arg2=(void *)0, void *arg3=(void *)0
#else __cplusplus
		void *, void *, void *
#endif __cplusplus
	);

END_EXTERNC
#endif __IO_EXTFUNCS_H__
