/*
 *   $RCSfile: io_intfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:45 $      
 */ 
#ifndef __IO_INTFUNCS_H__
#define __IO_INTFUNCS_H__
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

BEGIN_EXTERNC

extern void		IO_CheckDirection (int *, int *, int *, int, VOLREC *);
extern int		IO_Checker (VOLREC *);
extern int		IO_DeallocPages (SHORTPID, PAGESIZE, VOLREC *, LIST *, BOOL);
extern int		IO_ReallocPages (SHORTPID, PAGESIZE, VOLREC *, LIST *);
extern int		IO_DismountVolume (VOLREC *);
extern int		IO_FlushHeader (VOLREC *);
extern void		IO_InitRoot (ROOTPAGE *);
extern int		IO_MountVolume (VOLREC *const, const BOOL);
extern int		IO_OneTrackAll (int, int, PAGESIZE, int, VOLREC *, PID [], LIST *, LIST *);
extern int		IO_OneTrackPages (int, int, PAGESIZE, int, VOLREC *, PID [], LIST *, LIST *);
extern int		IO_ReadPage (VOLREC *, SHORTPID, int, char *);
extern int		IO_WritePage (VOLREC *, SHORTPID[], int[], char *[], int);
extern int		IO_LogPageMark ( PID *, int, BOOL, PAGEHASH *);
extern int		IO_LogPageUnique (PID *, int, UNIQUE, PAGEHASH *);
extern int		IO_MarkBitmapRange (BUFGROUP*, PID*, int, int, int);
extern VOLREC	*IO_FindVolumeId (VOLID);
extern VOLNAMEREC 	*IO_NewVolNameRec( const char *, VOLID );
extern	VOLREC 	*IO_NewVolRec(void);
extern	void 	IO_InsertVolRec(VOLREC *);
extern	void 	IO_RemoveVolRec(VOLREC *);
extern	void 	IO_FreeVolRec(VOLREC *);

END_EXTERNC
#endif __IO_INTFUNCS_H__
