#ifndef _LM_EXTFUNCS_H_
#define _LM_EXTFUNCS_H_
/*
 *   $RCSfile: lm_extfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:45 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

BEGIN_EXTERNC

extern int				lock (TRANSREC *, LOCKID *, LOCKMODE*, FLAGS, int, int);
extern int				lockCompatible (LOCKHEADER *, LOCKMODE);
extern int				lockFile (TRANSREC *, FID *, LOCKMODE*, FLAGS);
extern int				lockRootSlot (TRANSREC *, PID *, TWO, LOCKMODE, FLAGS);
extern LOCKMODE			getFileLockMode (TRANSREC *, FID *);
extern int				lockPage (TRANSREC *, PID *, LOCKMODE*, FLAGS);
extern int				unlock (TRANSREC *, LOCKID *, int);
extern void				unlockAll (TRANSREC *, int);
extern int				unlockPage (TRANSREC *, PID *, int);
extern void				releaseLockBlocked (TRANSREC *, int);
extern void				initializeLocks (void);
extern LOCKMODE			getLockMode (TRANSREC *, LOCKID *);
extern int				lm_CheckPage (TRANSREC *, PID *, FOUR *);
extern LOCKHEADER*		lm_GetLockHeader(PID* pid);
extern void				ageLocks(); /* forked in initializeServer() */
extern int				awaitLock(LOCKENTRY *, int); 

END_EXTERNC
#endif /* _LM_EXTFUNCS_H_ */
