#ifndef _LM_INTFUNCS_H_
#define _LM_INTFUNCS_H_
/*
 *   $RCSfile: lm_intfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:45 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

BEGIN_EXTERNC

extern LOCKCLASSREC	*allocLockClassRec (POOL *);
extern LOCKENTRY		*allocLockEntry (POOL *);
extern LOCKHEADER		*allocLockHeader (POOL *);
extern int				allocRuntimeClass (TRANSREC *);
extern int				checkDeadlock (TRANSREC *, LOCKENTRY *);
extern int				checkUpgradeDeadlock (LOCKHEADER *, LOCKMODE, LOCKMODE);
extern LOCKENTRY		*findLockEntry (LIST *, TRANSREC *);
extern LOCKHEADER		*findLockHeader (LOCKID *, int);
extern void			freeGrantedLock (LOCKENTRY *, int);
extern void			freeLockEntry (LOCKENTRY *, int);
extern void			freeLockWaiter (LOCKENTRY *, int);
extern void			freeUpgradeEntry (LOCKHEADER *, LOCKENTRY *, int);
extern LOCKMODE		getLockSupremum (LOCKHEADER *);
extern void			grantLockUpgrades (LOCKHEADER *);
extern void			grantLockWaiters (LOCKHEADER *);
extern int				hashLockId (LOCKID *);
extern LOCKENTRY		*heldLockEntry (TRANSREC *, LOCKHEADER *, LOCKMODE, FLAGS);

#ifdef DEBUG 
	/*
	 * This is a macro if DEBUG is not defined
	 */
	extern void			initLockHeader (LOCKHEADER *);
#endif 
extern int				lockCompatible (LOCKHEADER *, LOCKMODE);
extern LOCKENTRY		*newLockEntry (TRANSREC *, LOCKHEADER *, int);
extern void			preemptLock (LOCKHEADER *, LOCKMODE);
extern void			releaseUpgradeEntry (LOCKENTRY *, int);
extern int				upgradeLock (TRANSREC *, LOCKHEADER *, LOCKENTRY *, LOCKMODE, FLAGS);
extern char			*printLockId (LOCKID lockId);

END_EXTERNC


#ifndef DEBUG

/*
 *	define a macro to initialize the lock header
 */
#define initLockHeader(_lockHeader)		\
										\
{										\
										\
	/*									\
	 *	zero out the lock mode counts	\
	 */									\
	(_lockHeader)->modeCount[IS]  = 0;	\
	(_lockHeader)->modeCount[IX]  = 0;	\
	(_lockHeader)->modeCount[SH]  = 0;	\
	(_lockHeader)->modeCount[SIX] = 0;	\
	(_lockHeader)->modeCount[EX]  = 0;	\
										\
	/*									\
	 *	zero out the lock count			\
	 */									\
	(_lockHeader)->lockCount = 1;		\
}

#endif


#endif /* _LM_INTFUNCS_H_ */
