#ifndef _LOG_EXTFUNCS_H_
#define _LOG_EXTFUNCS_H_
/*
 *   $RCSfile: log_extfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:45 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

BEGIN_EXTERNC

extern int		compareLSN (LSN *, LSN *);
extern int   	compareLRC (LRC *, LRC *);
extern int		forceLog (FORCEMARK);
extern int		auditLogPage (GROUPLINK *);
extern void		forceDirtyPages (int);
extern void		asyncForceDirtyPages (int, LSN);
extern void		asyncForceDirtyPagesThread (void);
extern int		openLogFile (VOLREC *, int, int, BOOL);
extern int		regenLog (OPENLOG *);
extern void		closeLog (OPENLOG *);
extern FORCEMARK	writeLogRecord (TRANSREC *, LOGRECORDINFO *, LSN *, FLAGS);
extern int		writeTransStateRecord (TRANSREC *, int, int, ONE, BOOL);
extern void		removeLogList (TRANSREC *);
extern void		openLogDisk (void);
extern void		undoTransaction (LSNOFFSET, LSNOFFSET, FLAGS);
extern void		releaseLogBlocked (TRANSREC *, int);
extern int		reserveClientLogPage (TRANSREC *, SHORTPID *);
extern int		convertClientLogPage (GROUPLINK *, SHORTPID, TRANSREC *, LSN *,
									  LSN *, LSNOFFSET *, int *);
extern FORCEMARK	updateEndOfLog (TRANSREC *, GROUPLINK *, SHORTPID, 
									LSNOFFSET, LSN *, LSN *, int);

extern FORCEMARK	writeNonTransLogRecord(LOGRECORDINFO*, LSN*, FLAGS);
extern int		forkCheckpointAndWait(BOOL);
extern void		preflushLogThread();
extern void		checkpointThread();
extern int		setLogStartLocation(int);
extern void		activateLogging();
extern void		activateCheckpoint(BOOL force, BOOL flush, BOOL wait);


END_EXTERNC
#endif /* _LOG_EXTFUNCS_H_ */
