#ifndef _LOG_GLOBALS_H_
#define _LOG_GLOBALS_H_
/*
 *   $RCSfile: log_globals.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:45 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "openlog.h"

/* see space.c for descriptions */
extern OPENLOG		OpenLog;
extern LINK			LogLink;
extern BOOL			RecoverLog;
extern LSN			LastFlushedCheckpoint;
extern LSN			OldestDirtyPageLSN;

/*
 *  Control preflushing of log pages
 */
extern BOOL			LogPreflushOn;

/*
 *  All volumes mounted by transactions at the time of a
 *  checkpoint and their count
 */
extern VOLIDNAME	*CheckpointVolumes;
extern unsigned int    		CheckpointVolumeCount;

/* log preflush thread flushes to this mark */
extern FORCEMARK	LogPreflushMark;

/* number of potentially dirty pages in the log write buffer group */
extern int			PotentialDirtyLogPages;

/* log preflush thread waits on this list */
extern LIST			LogPreflushWaitList;

/* preflush log when more than this many pages are available */
extern int			LogPreflushTarget;

/* checkpoint thread waits on this list */
extern LIST			CheckpointWaitList;

/* indicates if checkpoint thread should synch force dirty pages */
extern BOOL			CheckpointSyncForce;

/*
 *  Indicates whether checkpoints can be taken at this time.
 *  The only time they cannot be taken is during analysis, redo,
 *  and log regeneration.
 */
extern BOOL        CheckpointsEnabled;


/* total log space used by active transactions */
extern unsigned int 		ActiveLogSpace;

/* Starting wrap count option for the log */
extern int			LogStartWrapCount;

/* asynchrounous page flush thread waits here */
extern LIST			DirtyPageFlushWaitList;

extern VOLID LogVolid;
#endif /* _LOG_GLOBALS_H_ */
