#ifndef _LOG_INTFUNCS_H_
#define _LOG_INTFUNCS_H_
/*
 *   $RCSfile: log_intfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:45 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

BEGIN_EXTERNC

extern void			abortLogList (OPENLOG *);
extern void			abortLogSpace (OPENLOG *, int);
extern TRANSVOLREC	*addTransVolRec (TRANSREC *, VOLREC *);
extern int			calculateLogSpace (OPENLOG *, int);
extern int			combineRecord (OPENLOG *, LOGRECORDHDR *, int, BOOL, GROUPLINK *);
extern GROUPLINK	*getLogRecordBuffer (int size);
extern void			freeLogRecordBuffer (GROUPLINK *);
extern int			checkPoint (BOOL);
extern void			removeLogList (TRANSREC *);
extern void			updateLogPageHeader (OPENLOG *, SHORTPID);
extern void			writeImage (OPENLOG *, LOGRECORDINFO *, int, LSNOFFSET*);
extern void			writeLogPageHeader (OPENLOG *, SHORTPID);
extern LSN			writeLogRecordHeader (OPENLOG *, LOGRECORDHDR *, LSNOFFSET*);
extern void			undoAction (LOGRECORDHDR *);
extern LSNOFFSET	findOldestLSN (OPENLOG *, LSN, int);
extern int			checkPointTrans (CHECKTRANS *);
extern int			checkPointDirtyPages (void);
extern int			checkPointVolumes (VOLIDNAME *);
extern void			preflushLog();

END_EXTERNC
#endif /* _LOG_INTFUNCS_H_ */
