#ifndef _MSG_FUNCS_H_
#define _MSG_FUNCS_H_
/*
 *   $RCSfile: msg_funcs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:45 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

BEGIN_EXTERNC

extern int		reply (int, int, int, BOOL);
extern void		clearLink (LINK *);
extern void		clientConnect (LINK *);
extern void		clientReceive (LINK *);
extern void		connectInitialize (void);
extern void		freeClientLink (LINK *);
extern void		timeoutClientLink (LINK *);
extern void		initializeLinks (void);
extern void		initializeMsg (int);
extern void		loop (void);
extern void		makeConn (MESSAGE *);
extern void		pipeError (void);
extern int		receive (LINK *, char *, int);
extern int      receiveDatagram (LINK *, char *, int);
extern void     serverReceive (LINK *);
extern void		resumeLink (LINK *);
extern int		selectReceive (BITVEC *);
extern void		setLink (LINK *);
extern int		setSelectBits (int);
extern void		suspendLink (LINK *);
extern void		freeLinkResources (LINK *);
extern void		freeLinkVolumes (LINK *);
extern void		timeOutClient(); /* ONLY to be forked (once) */
extern void		initializeStdin(); 
#ifdef DEBUG
extern void		DumpTimers(); 
#endif DEBUG

END_EXTERNC

#endif /* _MSG_FUNCS_H_ */
