/*
 *   $RCSfile: msg_globals.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:45 $      
 */ 
#ifndef __MSG_GLOBALS_H__
#define __MSG_GLOBALS_H__

/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "ess.h"
#include "sysdefs.h"
#include "list.h"
#include "link.h"
#include "bitvec.h"
#include "msgvector.h"

extern int			NumLinks;
extern LIST			FreeLinks;
extern LIST			UsedLinks;
extern LINK			*Links;

extern int			NumMsgBufs;

extern int			ServePort;
extern char 		*ServeName;
extern int			SelectBits;
extern BITVEC		SelectMask;
extern BITVEC		DiskMask;
extern BITVEC		AllMask;
extern BITVEC		ReadMask;
extern BITVEC		WorkMask;
extern int			DiskIndex;
extern int			AllIndex;
extern BOOL			SelectRestrict;
extern TIMEVAL		*SelectTime;
extern int			ConnectReply;
extern MSGVECTOR	MsgVectorTable[];
extern BOOL			RunInBackground;
extern int			fdUdp;
extern int			fdTcp;

extern	BOOL		AwakenedAThread; /* used by WakeUp/Loop (in sleep.C) */


#endif __MSG_GLOBALS_H__
