/*
 *   $RCSfile: msgvector.h,v $  
 *   $Revision: 1.4 $  
 *   $Date: 1996/05/05 03:11:28 $      
 */ 
#ifndef __MSGVECTOR_H__
#define __MSGVECTOR_H__

/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
/*
 *	define a type of function that takes a link and a message parameter
 */
#ifdef __cplusplus
/* sorry guys, g++ 2.7.2 won't accept just 'LINK *' for some reason
 */
typedef void (*MSGFUNCTION)(MESSAGE *, struct Link_s *);

#elif c_plusplus

typedef void (*MSGFUNCTION)(MESSAGE *, LINK *);

#else

typedef void (*MSGFUNCTION)();

#endif


/*
 *	define the jump vector for the message type
 */
typedef struct {


	MSGFUNCTION	function;		/* function to call for this message	*/
	short		linkClass;		/* class message can be received on		*/
	short		msgtype;		/* for sanity checks */

} MSGVECTOR;
#endif __MSGVECTOR_H__
