#ifndef _OP_H_
#define _OP_H_
/*
 *   $RCSfile: op.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:45 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

/*
 *	define the type of a path
 */
typedef TWO		PATHINDEX;
typedef ONE		MSGCLASS;
typedef FOUR	TAG;
typedef TWO		MSGTYPE;


/*
 *	define the structure of a path record for use in the client
 */
typedef struct	{

	PATHINDEX	pathIndex;
	TWO			referenceCount;
	TAG			tag;
	FOUR		unique;

} PATHRECORD;



/*
 *	define the type of a message qualifier
 */
typedef struct	{

	MSGCLASS	messageClass;
	TAG			*tag;
	UTWO		pathCount;
	UTWO		
	UFOUR		bodyLength;
	MSGTYPE		messageType;

} QUALIFIER;

#endif /* _OP_H_ */
