#ifndef _REDO_EXTFUNCS_H_
#define _REDO_EXTFUNCS_H_
/*
 *   $RCSfile: redo_extfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:45 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#ifdef __cplusplus
extern "C" {
#endif


extern void		redoFileKeyInsert (LOGRECORDHDR *);
extern void		redoFileKeyDelete (LOGRECORDHDR *);
extern void		redoFileRootFormat (LOGRECORDHDR *);
extern void		redoGetUnique (LOGRECORDHDR *);
extern void		redoPageAllocation (LOGRECORDHDR *);
extern void		redoPageDeallocation (LOGRECORDHDR *);
extern void		redoPageMark (LOGRECORDHDR *);
extern void		redoSetRootEntry (LOGRECORDHDR *);
extern void		redoUnSetRootEntry (LOGRECORDHDR *);
extern void		redoRemoveRootEntry (LOGRECORDHDR *);
extern void		redoSlottedFormat (LOGRECORDHDR *);
extern void		redoSplitFileNode (LOGRECORDHDR *);
extern void		redoMarkLargeObjOnPage (LOGRECORDHDR *);
extern void		redoUnMarkLargeObjOnPage (LOGRECORDHDR *);
extern void		redoFileAddSlotted (LOGRECORDHDR *);
extern void		redoFileRemoveSlotted (LOGRECORDHDR *);
extern void		redoLgNodePageFormat (LOGRECORDHDR *);
extern void		redoLgDataPageFormat (LOGRECORDHDR *);

/*
 *	small object operations
 */
extern void		redoWriteSmallObj (LOGRECORDHDR *);
extern void		redoCreateSmallObj (LOGRECORDHDR *);
extern void		redoDestroySmallObj (LOGRECORDHDR *);
extern void		redoInsertSmallObj (LOGRECORDHDR *);
extern void		redoAppendSmallObj (LOGRECORDHDR *);
extern void		redoDeleteSmallObj (LOGRECORDHDR *);
extern void		redoForwardSmallObj (LOGRECORDHDR *);
extern void		redoChangeSmallObjHdr (LOGRECORDHDR *);

/*
 *	large object operations
 */
extern void		redoInitLargeNode (LOGRECORDHDR *);
extern void		redoWriteLargeNode (LOGRECORDHDR *);
extern void		redoWriteLargeData (LOGRECORDHDR *);
extern void		redoInsertLargeData (LOGRECORDHDR *);
/* extern void		redoAppendLargeData (LOGRECORDHDR *); */
/* extern void		redoRemoveLargeData (LOGRECORDHDR *); */
/* extern void		redoAppendLargeSlots (LOGRECORDHDR *);*/
extern void		redoWriteLargeSlots (LOGRECORDHDR *);
extern void		redoRemoveLargeSlots (LOGRECORDHDR *);
extern void		redoConvertToLargeRoot (LOGRECORDHDR *);
extern void		redoConvertToLargeHdr (LOGRECORDHDR *);
extern void		redoConvertToSmall (LOGRECORDHDR *);
extern void		redoUndoConvertToLargeRoot (LOGRECORDHDR *);
extern void		redoUndoConvertToLargeHdr (LOGRECORDHDR *);
extern void		redoChangeSlotByteCounts (LOGRECORDHDR *);

/*
 *	btree operations
 */
extern void 	redoBtreePageFormat(LOGRECORDHDR* record);
extern void		redoBtree(LOGRECORDHDR* record);

/*
 *	Btree overflow pages operations
 */
extern void		redoBtOv(LOGRECORDHDR* record);

extern void 	redoNdxDescPageFormat(LOGRECORDHDR* record);
extern void		redoCreateIndex(LOGRECORDHDR* record);

/*
 *	linear hashing operations
 */
extern void		redoLHash(LOGRECORDHDR* record);

/*
 *	Full page operations
 */
extern void		redoEntirePage(LOGRECORDHDR*);

/*
 *	Distributed transaction operations
 */
extern void		redoCoordPrepare(LOGRECORDHDR *, LSNOFFSET);
extern void		redoServerPrepare(LOGRECORDHDR *, LSNOFFSET);
#ifdef __cplusplus
}
#endif


#endif /* _REDO_EXTFUNCS_H_ */
