#ifndef _REDO_INTFUNCS_H_
#define _REDO_INTFUNCS_H_
/*
 *   $RCSfile: redo_intfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:45 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

#include	"logprepare.h"

extern BOOL		redoCheckPage (LOGRECORDHDR *, GROUPLINK **, PAGETYPE);

extern void		redoGetServers (LOGRECORDHDR *, TRANSREC *);
extern void		redoAcquireLocks (TRANSREC *, int, PREPARELOCKINFO *);
extern void		redoPreparedVols (TRANSREC *, int, VOLIDNAME *);
extern void		redoServerPrepareHdr (TRANSREC *, SERVERPREPAREHDR *);
extern void		redoCoordPrepareHdr (TRANSREC *, COORDPREPAREHDR *);

#ifdef __cplusplus
}
#endif


/*
 * This macro checks to see if if the lrc on the page is greater
 * than the lrc in the log record.  It also checks the lsn for the case
 * of pages which never made it back from the client.
 */
#define CHECK_PAGE_LRC_LESS_DIRTYINFO(_recLrc, _recLsn, _dirtyInfo) \
	((compareLRC(&(_recLrc), &((_dirtyInfo)->lrc)) < 0) || 			\
	 (compareLSN(&(_recLsn), &((_dirtyInfo)->lsn)) < 0)	)



#endif /* _REDO_INTFUNCS_H_ */
