/*
 *   $RCSfile: threadstate.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:45 $      
 */ 
#ifndef __THREADSTATE_H__
#define __THREADSTATE_H__

/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
/*
 *	define the states that the task can have
 */
#define THREAD_ACTIVE				0
#define THREAD_LOOP					-1
#define THREAD_INACTIVE				-2
#define THREAD_SEMAPHORE_WAIT		1
#define THREAD_SH_LATCH_WAIT		2
#define THREAD_EX_LATCH_WAIT		3
#define THREAD_SPARE_TCB			4
#define THREAD_DISK_WAIT			5
#define THREAD_RECEIVE_WAIT			6
#define THREAD_DISKOPEN_WAIT		7
#define THREAD_DISKCLOSE_WAIT		8
#define THREAD_LOCK_WAIT			9
#define THREAD_LOCKUPGRADE_WAIT		10	
#define THREAD_LOG_QUIESCE_WAIT		11	
#define THREAD_TRANS_QUIESCE_WAIT	12	
#define THREAD_LOG_RECOVERY_WAIT	13	
#define THREAD_BUFGROUP_WAIT		14	
#define THREAD_CHECKPOINT_WAIT		15  /* waiting to perform a checkpoint */
#define THREAD_DISKFORMAT_WAIT		16
#define THREAD_LOG_CLOSE_WAIT		17	
#define THREAD_DISK_Q_WAIT			18
#define	THREAD_TRANS_SHUTDOWN_WAIT	19
#define	THREAD_LOG_PREFLUSH_WAIT	20
#define	THREAD_READY_WAIT			21	/* thread released the cpu and
											is ready and waiting to run */
#define	THREAD_RECOVER_UNDO_WAIT	22
#define	THREAD_WAKEUP_WAIT			23
#define	THREAD_TIMER_IN_USE			24

#define	THREAD_PAGEFLUSH_WAIT		25  /* waiting to perform async dirty page flush */
#define	THREAD_FORK_WAIT			26  /* waiting for a free thread so fork can be performed */

#define	THREAD_COORD_WAIT			27
#define MAX_THREADSTATE				27	/* if this is incremented, please
										 * also update dumpTcbs
										 */

#endif __THREADSTATE_H__
