/*
 *   $RCSfile: undo.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:46 $      
 */ 
#ifndef __UNDO_H__
#define __UNDO_H__

/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
/*
 *	define a record that hold information concerning missing updates
 *	to page pages.
 */
typedef struct _MissingUpdateInfo {
	
	LISTELEMENT	list;		/* list of free/used tables 			*/
	LIST		*table;		/* pointer to a malloced table			*/
	MAGIC		magic;
} MISSINGUPDATEINFO;


#define MISSINGUPDATEINFO_MAGIC 0x576435ab

/*
 *	Define entries in the missing update table
 */
typedef struct {

	PID			pid;
	LRC			lrc;
	LRC			firstLRC;	/* first operation not done	*/
	LSN			firstLSN;	/* first operation not done	*/
	LISTELEMENT	list;
	PAGETYPE	pageType;

} MISSINGUPDATE;


/*
 *  define the magic checking macros
 */
#if MAGIC_CHECKING IS_ENABLED


#define INIT_MISSINGUPDATEINFO_MAGIC(_missingUpdateInfo)            \
    (_missingUpdateInfo)->magic = MISSINGUPDATEINFO_MAGIC;

#define CHECK_MISSINGUPDATEINFO_MAGIC(_missingUpdateInfo)           \
                                                                    \
    if ((_missingUpdateInfo)->magic != MISSINGUPDATEINFO_MAGIC)   { \
                                                                    \
        SM_ERROR(TYPE_FATAL, esmINTERNAL);                          \
    }


#else

#define INIT_MISSINGUPDATEINFO_MAGIC(_missingUpdateInfo)
#define CHECK_MISSINGUPDATEINFO_MAGIC(_missingUpdateInfo)

#endif 
#endif __UNDO_H__
