#ifndef _UNDO_EXTFUNCS_H_
#define _UNDO_EXTFUNCS_H_
/*
 *   $RCSfile: undo_extfuncs.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:46 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

extern void		undoPageAllocation (LOGRECORDHDR *);
extern void		undoPageDeallocation (LOGRECORDHDR *);
extern void		undoPageMark (LOGRECORDHDR *);
extern void		undoFileKeyInsert (LOGRECORDHDR *);
extern void		undoMarkLargeObjOnPage (LOGRECORDHDR *);
extern void		undoSetRootEntry (LOGRECORDHDR *);
extern void		undoRemoveRootEntry (LOGRECORDHDR *);
extern void		undoFileAddSlotted (LOGRECORDHDR *);
extern void		undoFileCreateDone (LOGRECORDHDR *);

/*
 *	Small object ops
 */
extern void		undoWriteSmallObj (LOGRECORDHDR *);
extern void		undoCreateSmallObj (LOGRECORDHDR *);
extern void		undoDestroySmallObj (LOGRECORDHDR *);
extern void		undoDestroySmallObjND (LOGRECORDHDR *);
extern void		undoInsertSmallObj (LOGRECORDHDR *);
extern void		undoAppendSmallObj (LOGRECORDHDR *);
extern void		undoDeleteSmallObj (LOGRECORDHDR *);
extern void		undoForwardSmallObj (LOGRECORDHDR *);
extern void		undoChangeSmallObjHdr (LOGRECORDHDR *);

/*
 *	Large object ops
 */
extern void		undoWriteLargeNode (LOGRECORDHDR *);
extern void		undoWriteLargeData (LOGRECORDHDR *);
extern void		undoAppendLargeData (LOGRECORDHDR *);
extern void		undoRemoveLargeData (LOGRECORDHDR *);
extern void		undoInsertLargeData (LOGRECORDHDR *);
extern void		undoDeleteLargeData (LOGRECORDHDR *);
extern void		undoWriteLargeSlots (LOGRECORDHDR *);
extern void		undoAppendLargeSlots (LOGRECORDHDR *);
extern void		undoRemoveLargeSlots (LOGRECORDHDR *);
extern void		undoConvertToLargeRoot (LOGRECORDHDR *);
extern void		undoConvertToLargeHdr (LOGRECORDHDR *);
extern void		undoChangeSlotByteCounts (LOGRECORDHDR *);
extern void		undoConvertToSmall (LOGRECORDHDR *);


#ifndef INIT_LRC_IS_LSN
extern MISSINGUPDATE*	addUndoPage (LIST*, PID*, LRC*, LSN*, LRC*, PAGETYPE);
extern MISSINGUPDATE*	lookupUndoPage (LIST*, PID*);
extern void				removeUndoPage (LIST*, PID*);
extern MISSINGUPDATEINFO*	setupMissingUpdateInfo ();
extern void				freeMissingUpdateInfo ();
extern void				initMissingUpdatePools ();
extern void				recordMissingUpdate ( BOOL, LRC**, 
		MISSINGUPDATEINFO*, PID *, LRC *, PAGEHASH*, LOGRECORDHDR*, PAGETYPE );
#else INIT_LRC_IS_LSN
extern void				recordMissingUpdate ( BOOL, LRC**, PID *, LRC *);
#endif INIT_LRC_IS_LSN

#ifndef INIT_LRC_IS_LSN

#define INIT_MISSING_UPDATE_INFO(z)\
	MISSINGUPDATEINFO 	*missingUpdateInfo =\
		((TRANSREC*)(z))->missingUpdateInfo;

#define RECORD_MISSING_UPDATE(_a,_b,_c,_d,_e,_f,_g,_h)\
	recordMissingUpdate(_a,_b,_c,_d,_e,_f,_g,_h)

#else INIT_LRC_IS_LSN

#define INIT_MISSING_UPDATE_INFO(z)

#define RECORD_MISSING_UPDATE(_a,_b,_c,_d,_e,_f,_g,_h)\
	recordMissingUpdate(_a,_b,_d,_e)

#endif INIT_LRC_IS_LSN

/*
 *	Btree index operations
 */
extern void		undoBtree(LOGRECORDHDR*);
extern void		undoCreateIndex(LOGRECORDHDR*);

/*
 *	Btree overflow pages operations
 */
extern void		undoBtOv(LOGRECORDHDR*);

/*
 *  Full page operations
 */
extern void     undoFileKeyDelete (LOGRECORDHDR *);
extern void     undoFileKeyInsertDone (LOGRECORDHDR *);
extern void     undoEntirePage(LOGRECORDHDR*);

/* 
 * Linear hashing operations
 */
extern void     undoLHash(LOGRECORDHDR*);


#ifdef __cplusplus
}
#endif

#endif /* _UNDO_EXTFUNCS_H_ */
