/*
 *   $RCSfile: space.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:46 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "pool.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "latch.h"
#include "semaphore.h"
#include "link.h"
#include "lsn.h"
#include "bf.h"
#include "volume.h"
#include "io_intfuncs.h"
#include "io_globals.h"
#include "sm_params.h"

/*
 * Global statistics.
 */
int		IO_DiskReads = 0;
int		IO_DiskWrites = 0;

/*
 *	Pools for delayed deallocation info
 */
POOL	PageDeallocInfoPool;
POOL	FileDeallocInfoPool;


/*
 *	This variable is used by the formatvol program to get around
 *	all sorts of assumptions made in the server code .
 */
BOOL 	formatvolRunning = FALSE;

/*
 *  prevents disk processes from being forked, and ensures
 *  that i/o is done only with the "fast path"
 */
	
BOOL 	FastPathOnly = FALSE;

/*
 *	PreventFastPath prevents the system from shortcircuiting the
 *	use of the disk I/O processes.  This is necessary to perform
 *	I/O's in parallel.  The variable is incremented each time
 *	prevention is needed and decremented when it is not.  It should
 *	never become negative.  See the macro's in io_globals.h
 */
int 	PreventFastPath = 0;

BOOL 	PrintExtraStats = FALSE;
int		MaxAddVolumes = 0;
