/*
 *   $RCSfile: getLockSupremum.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:51 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "pool.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "semaphore.h"
#include "link.h"
#include "lsn.h"
#include "latch.h"
#include "bf.h"
#include "volume.h"
#include "trans.h"
#include "lm_intfuncs.h"
#include "lm_extfuncs.h"
#include "lock_globals.h"


 LOCKMODE
getLockSupremum (

	register LOCKHEADER	*lockHeader 
)
{

	register int		lockMode;
	register UONE		*lockCount;

	/*
	 *	search starting at one less than the current supremum
	 *    (MJZ: 6-22-90 -- start for loop at supremum instead)
	 */
	for (lockMode = lockHeader->supremum,
		 lockCount = &(lockHeader->modeCount[lockMode]);
		 lockMode > NL;
		 lockMode--, lockCount--)	{

		TRPRINT(TR_LOCK, TR_LEVEL_1, ("checking mode:%s", GETMODE(lockMode)));

		/*
		 *	check to see if the count is non zero
		 */
		if (*lockCount != 0)	{

			TRPRINT(TR_LOCK, TR_LEVEL_2, ("new supremum:%s", GETMODE(lockMode)));
			return(lockMode);
		}
	}

	/*
	 *	This means that there are no holders of the lock
	 */
	return(NL);
}
