/*
 *   $RCSfile: checkPointVolumes.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:50 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "pool.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "semaphore.h"
#include "latch.h"
#include "link.h"
#include "lsn.h"
#include "bf.h"
#include "volume.h"
#include "openlog.h"
#include "trans.h"
#include "logrecs.h"
#include "log_intfuncs.h"
#include "log_globals.h"
#include "io_extfuncs.h"
#include "io_globals.h"

static BOOL
doit(
	VOLREC 	*volRec,
	VOLIDNAME *volumeList,
	int 	*volumeCount
)
{
	if (((volRec->volflags & (VOL_OPEN|VOL_QUIESCE))!=0) &&
		((volRec->volflags & VOL_TEMP) == 0)) {
		
		volumeList[*volumeCount].volid = volRec->header->volid;
		strncpy(volumeList[*volumeCount].volName, 
			volRec->volNameRec->volName.name, 
			sizeof(volRec->volNameRec->volName.name));
		(*volumeCount)++;
	}
	return FALSE;
}

 int
checkPointVolumes (
	VOLIDNAME *volumeList
)
{
	int  	volumeCount;

	TRACE(TR_LOG, TR_LEVEL_1);

	volumeCount = 0;
	ForEachVolume(3, doit, volumeList, &volumeCount, 0 );

	return volumeCount;	
}
