/*
 *   $RCSfile: updateLogPageHeader.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:50 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "pool.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "semaphore.h"
#include "latch.h"
#include "link.h"
#include "lsn.h"
#include "bf.h"
#include "volume.h"
#include "openlog.h"
#include "trans.h"
#include "logrecs.h"
#include "log_intfuncs.h"
#include "log_extfuncs.h"
#include "thread_globals.h"

 void
updateLogPageHeader (

	OPENLOG				*openLog,
	SHORTPID			lastRecord 
)
{

	register LOGPAGEHDR	*pageHeader;


	TRPRINT(TR_LOG, TR_LEVEL_1, ("lastRecord:%d", lastRecord));

	SM_ASSERT(LEVEL_3, lastRecord >= FIRST_LSN);

	/* this thread must hold the semaphore */ 
	SM_ASSERT(LEVEL_3, openLog->writeSemaphore.holder == Active);

	/*
	 *	get a pointer to the page header
	 */
	pageHeader = (LOGPAGEHDR *) openLog->tailBuffer->bufFrame;

	/*
	 *	initialize the header on the page and align it
	 */
	pageHeader->lastRecord = lastRecord;

	/*
	 *	get a pointer to the end of the page
	 */
	pageHeader = (LOGPAGEHDR *) (((char *) pageHeader) + openLog->lastUsableByte);

	/*
	 *	initialize the header on the page
	 */
	pageHeader->lastRecord = lastRecord;
}
