#ifndef _PAGEDUMP_H_
#define _PAGEDUMP_H_
/*
 *   $RCSfile: pagedump.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:54 $      
 */ 
#ifndef __pagedump_h__
#define __pagedump_h__
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#define  FOUND			1
#define  NOTFOUND		0
#define  DUMP_COMPLETE	2

#define  DONE			1
#define  NOTDONE		0

#define  NONE			-1
#define  MASK			0x1
#define  NOWORDS		BITMAP_USABLESIZE/32

/*
#define BITS_IN_PAGE     (((unsigned long) BITMAP_USABLESIZE) * 8)
*/
#define MSB_MASK    0x80000000
#define BIT_TO_WORD(_bit)   (((ulong) _bit) >> 5)
#define BIT_IN_WORD(_bit)    (_bit & 0x1f)


#define  CNTRLFILE		"mr_cntrlfile"
#define  HASHSIGN		"#"

#define  MAXCTABLE		20
#define  MAXDTABLE              20
#define  MAXBITMAP              2

typedef  int  	FILEID;
typedef  char 	*PAGEBUF;

typedef struct  A{
LSN   		startLSN;	/* LSN of oldest dirty page in buffer   */
VOLHDR      volinfo;	/* Information about the volume		*/
int  		dumpNo;     /* The volume dump number		*/
int  		noofPages;	/* Number of pages being dumped		*/
UONE       	occupied;	/* The table is occupied */
}CONTROL;


typedef struct B{
int   		fd;		/* File id of the dump file		*/
int  		hfd;		/* File id of the hash file		*/
UONE  		inProgress;     /* Dump in progress or not		*/
SHORTPID	received;	/* Last page requested recd		*/
int 		bitpagerecd;	/* Last bitmap page received		*/
SHORTPID   	pageReq;	/* The last page requested		*/
int        nopagerecd;	/* No of pages recd so far		*/
CONTROL 	cntrl;		/* Control block for this dump		*/
BITMAPPAGE  bitmap[MAXBITMAP]; /* Bit map of the pages on disk	*/
}DUMP;

extern int     numCntrl;

extern CONTROL  CntrlTable[]; /* Maintained in a control file		*/
extern DUMP     DumpTable[];  /* In memory dump data structure	*/
#endif /* __pagedump_h__ */
#endif /* _PAGEDUMP_H_ */
