#ifndef _SERVER_STUB_H_
#define _SERVER_STUB_H_
/*
 *   $RCSfile: server_stub.h,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:54 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#define SM_PORT_NO  5555	/* port number on the storage manager side
				   for connecting to media recovery manager */

#define END_OF_FILE -1
typedef enum event_type {

	REGISTER = 1

} event_type;


#define PROCESS_DATA_PAGE 1
#define PROCESS_LOG_PAGE 2
#define IGNORE 3

#ifdef __cplusplus
extern "C" {
#endif

extern void handle_acks(packet*);
extern int DeliverRqDataPage( PID pid, LSN startLSN, int length, ONE *page);
extern int InformDumpDone(PID pid);
extern int GetNextDataPage( PID pid, int *length, GROUPLINK **groupLink);
extern int GetLogPageFromMR(PID pid, LSN startLSN);
extern int GetDataPageFromMR(PID pid);
extern int send_ack_packet_to_mr(int code, PID pid);
extern int handle_input(PID* pid, LSN* startLSN);
extern int PollMR( int *return_socket);
extern int InitiateDump( VOLHDR dump_vol_hdr, LSN startLSN);

#ifdef __cplusplus
}
#endif


#endif /* _SERVER_STUB_H_ */
