/*
 *   $RCSfile: clearLink.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:54 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "semaphore.h"
#include "link.h"
#include "bitvec.h"
#include "msgvector.h"
#include "msg_funcs.h"
#include "msg_globals.h"


 void
clearLink (

	register LINK	*link 
)
{
	TRPRINT(TR_MSG, TR_LEVEL_1, 
	("clearing receive on link:%d type %d", link->id, link->linkClass));

	if (link->linkClass == CL_DISK)	{
		/* clear the disk mask */
		bic( &(DiskMask), link->id);
		bic( &(SelectMask), link->id);
	} else if (!SelectRestrict)	{
		/* clear the select mask */
		bic( &(SelectMask), link->id);
	}
		
	/* clear the all mask bits */
	bic( &(AllMask), link->id);

#ifdef DEBUG
	/* grot- to find the loop.C select bug */
	link->address.sin_family = (u_short) link->linkClass;
#endif 
	link->flags = LINK_FREE; 
	link->linkClass = CL_UNUSED; 

	close(link->id);
}
