/*
 *   $RCSfile: mountRecoveryVolumes.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:55 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "pool.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "semaphore.h"
#include "latch.h"
#include "link.h"
#include "lsn.h"
#include "bf.h"
#include "logrecs.h"
#include "volume.h"
#include "openlog.h"
#include "trans.h"
#include "recover_intfuncs.h"
#include "io_extfuncs.h"
#include "log_globals.h"


 int
mountRecoveryVolumes ()
{
	VOLREC 	*volRec;
	int 	i;

	TRACE(TR_RECOVER, TR_LEVEL_1);

	/*
	 *	Mount each volume in the recovery volume table
	 */
	for (i = 0; i < CheckpointVolumeCount; i++) {
		
		/*
		 *	Mount the volume if it is not the log volume
		 */
		if (OpenLog.volid != CheckpointVolumes[i].volid) {

			/*
			 *  attempt to open the volume
			 */
			if ((volRec = io_MountVolume(CheckpointVolumes[i].volid, FALSE)) == NULL) {

				/*
				 *	The mount failed
				 */
				return(esmFAILURE);
			}
		}
	}

	return(esmNOERROR);
}
