/*
 *   $RCSfile: redoPrepareHdr.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:55:58 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "pool.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "latch.h"
#include "semaphore.h"
#include "link.h"
#include "lsn.h"
#include "bf.h"
#include "log.h"
#include "volume.h"
#include "trans.h"
#include "logrecs.h"
#include "bitmap.h"
#include "openlog.h"
#include "logaction.h"
#include "io_extfuncs.h"
#include "io_logfuncs.h"
#include "bf_extfuncs.h"
#include "bm_extfuncs.h"
#include "trans_extfuncs.h"
#include "redo_intfuncs.h"
#include "redo_extfuncs.h"
#include "util_funcs.h"
#include "thread_globals.h"
#include "logprepare.h"
#include "log_globals.h"
#include "log_extfuncs.h"
#include "distr.h"


 void
redoServerPrepareHdr (

	TRANSREC				*transRec,
	SERVERPREPAREHDR		*prepareHdr
)
{
	/*
	 *	fill in the coordAddr and coordTid into the transRec
	 */
	transRec->coordAddr = prepareHdr->coordAddr;
	transRec->coordTid = prepareHdr->coordTid;
	transRec->prepareLSN = prepareHdr->prepareLSN;
	transRec->firstLogPid = prepareHdr->firstLogPid;
	transRec->logUnique = prepareHdr->logUnique;
	transRec->firstLSN = prepareHdr->firstLSN;
	transRec->logRecordCount = prepareHdr->logRecordCount;
	transRec->logSpace = prepareHdr->logSpace;


	/*
	 *	return success
	 */
	return;

}

 void
redoCoordPrepareHdr (

	TRANSREC				*transRec,
	COORDPREPAREHDR			*prepareHdr
)
{
	/*
	 *	fill in the transRec 
	 */
	transRec->numServers = prepareHdr->numServers;
	transRec->prepareAndCommit = prepareHdr->prepareAndCommit;
	transRec->prepareLSN = prepareHdr->prepareLSN;
	transRec->firstLogPid = prepareHdr->firstLogPid;
	transRec->logUnique = prepareHdr->logUnique;
	transRec->firstLSN = prepareHdr->firstLSN;
	transRec->logRecordCount = prepareHdr->logRecordCount;
	transRec->logSpace = prepareHdr->logSpace;

	if (transRec->prepareAndCommit == TRUE)
	   transRec->clientCommand = C_COMMIT;


	/*
	 *	return success
	 */
	return;

}
