/*
 *   $RCSfile: createResource.c,v $  
 *   $Revision: 1.4 $  
 *   $Date: 1996/05/05 03:42:34 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "semaphore.h"
#ifdef __linux__
/* some other link.h exists. somewhere */
#include "../include/link.h"
#else
#include "link.h"
#endif
#include "bitvec.h"
#include "msgvector.h"
#include "resource.h"
#include "resource_funcs.h"
#include "util_funcs.h"
#include "resource_globals.h"


 RESOURCE
*createResource (

	RESOURCETYPE		type,
	struct Link_s				*link,
	char				*pointer 

)
{

	register RESOURCE	*resource;


	TRACE(TR_MSG, TR_LEVEL_1);

	/*
	 *	attempt to get a resource from the free list
	 */
	if ((resource = (RESOURCE *) listDeq( &FreeResources )) == NULL)	{

		return(NULL);
	}

	/*
	 *	initialize the resource
	 */
	resource->unique  = random();
	resource->type	  = type;
	resource->flags	  = RESOURCE_ACTIVE;
	resource->pointer = pointer;
	resource->link	  = link;

	/*
	 *	hang the resource off the link list
	 */
	listEnq( &(link->resourceList), &(resource->linkList) );

	/*
	 *	return the resource
	 */
	return(resource);
}
