/*
 *   $RCSfile: abortLink.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:56:02 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "pool.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "semaphore.h"
#include "link.h"
#include "lsn.h"
#include "latch.h"
#include "bf.h"
#include "volume.h"
#include "trans.h"
#include "trans_intfuncs.h"
#include "trans_extfuncs.h"
#include "thread_funcs.h"
#include "thread_globals.h"
#include "trans_globals.h"


 void
abortLink (

	LINK		*link 
)
{

	TRANSREC	*transRec;


	TRACE(TR_TRANS|TR_MSG, TR_LEVEL_1);

	/*
	 *	fire off aborts for this link
	 */
	while ((transRec = (TRANSREC *) listDeq( &(link->transList) )) != NULL)	{

		/*
		 *	check the transaction magic number
		 */
		CHECK_TRANSREC_MAGIC(transRec);

		/*
		 *	mark the transaction as aborting
		 */
		/*
		 *	PRAKASH: no need - internalAbort will take care of it
		 *			 if necessary
		 */
		/* transRec->intent = T_ABORT; */

		SM_ASSERT(LEVEL_1, transRec->transState != T_INACTIVE);

		/*
		 *	abort the transaction
		 */
		internalAbort(transRec, esmNOTCONNECTED);
	}
}
