/*
 *   $RCSfile: stat_space.c,v $  
 *   $Revision: 1.1.1.1 $  
 *   $Date: 1996/05/04 21:56:03 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "queue_consist.h"

/* 
 * Server statistics:
 * The convention for declaring & using these deviates
 * from the convention for the rest of the source.
 * stat_globals.h includes the decls for each stat variable, but
 * it's included ONLY by this file and by the funcs that combine
 * stats and ship them to a client.  Each func that updates a stat
 * variable simply declares the variable as an external int.
 * The reason for this is that we don't want to recompile the whole
 * bloomin's server each time a statistic is added.
 */

#include "stat_globals.h"

/*
 * inter-transaction caching:
 *  -itx_client_current is #times client's LRC allowed the server
 * 	 to skip sending a page.
 *  -itx_client_old is #times client's LRC was out of date.
 *  -itx_server_foilded is #times client's LRC was out ok but the
 * 	  server had to read from disk to find out the real lrc.
 */
int itx_client_current = 0, itx_client_old = 0, itx_server_foiled = 0,
	itx_lrc_lookups=0, itx_lrc_finds=0;

/*
 *  page cache stats
 */

int cache_hits = 0, cache_misses = 0, swaps = 0, noswaps = 0;


/* 
 *  server <--> diskproc performance info 
 */
int	disk_requests = 0;	/* times request sent to disk proc */
int	fast_path_taken = 0;/* times request honored by server process
								instead of disk process */
int	slow_path_taken = 0;/* times request honored by disk process */

int	serv_sleeps = 0, 	/* server slept on select() */
	serv_polls = 0,		/* server polled with non-blocking select() */
	serv_sel_intrs = 0; 	/* select() interrupted */

int sel_connects = 0,
	sel_disks = 0,
	sel_clients = 0,   	/* returned from select() to handle this  */
	sel_stdin = 0, 		/* type of request                        */
	sel_media = 0,
	sel_dgrams = 0; 

int	serv_v_ops;					/* awakened a disk proc with a V */
int disk_replies_found = 0, 	/* found reply in a shm queue */
	disk_replies_kicked = 0,	/* server awakened by disk process */ 
	unnecessary_kicks = 0,		/* kicks for replies already found */
	disk_requests_out = 0,		/* disk messages sent, not replied */
	threads_awaiting_q = 0;		/* threads awaiting queue space to send msg */

/* TODO: remove */ int	loops = 0,  loop_spare = 0, loop_ran_ready = 0;
